// class MatlabInterface
// Timothee Cour, 30-Sep-2010 01:54:13 -- DO NOT DISTRIBUTE

#pragma once
#include <typeinfo>
#include "matlab_interface_macros.cpp"
#include "mat.h"

//#define ClassID2type(classID) typeof (double)
//#define ClassID2type(classID)\
//if(classID==mxDOUBLE_CLASS) typeof (double)
////       ({ typeof (a) _a = (a); \
////           typeof (b) _b = (b); \
////         _a > _b ? _a : _b; })

//unsigned char index=MatlabInterface::classID2uint8(mxLOGICAL_CLASS);

/*
 * mxUNKNOWN_CLASS
 * mxCELL_CLASS
 * mxSTRUCT_CLASS
 * mxLOGICAL_CLASS
 * mxCHAR_CLASS
 * mxDOUBLE_CLASS
 * mxSINGLE_CLASS
 * mxINT8_CLASS
 * mxUINT8_CLASS
 * mxINT16_CLASS
 * mxUINT16_CLASS
 * mxINT32_CLASS
 * mxUINT32_CLASS
 * mxINT64_CLASS
 * mxUINT64_CLASS
 * mxFUNCTION_CLASS
 */

/*
 *numeric
 *
 * mxLOGICAL_CLASS
 * mxDOUBLE_CLASS
 * mxSINGLE_CLASS
 * mxINT8_CLASS
 * mxUINT8_CLASS
 * mxINT16_CLASS
 * mxUINT16_CLASS
 * mxINT32_CLASS
 * mxUINT32_CLASS
 * mxINT64_CLASS
 * mxUINT64_CLASS
 */


class MatlabInterface {
public:
    static unsigned char classID2uint8(mxClassID classID){
        return (unsigned char)classID;
    }
    static mxClassID uint82classID(unsigned char index){
        if(index==0) return  mxUNKNOWN_CLASS;
        if(index==1) return  mxCELL_CLASS;
        if(index==2) return  mxSTRUCT_CLASS;
        if(index==3) return  mxLOGICAL_CLASS;
        if(index==4) return  mxCHAR_CLASS;//caution:there is no "5"
        if(index==6) return  mxDOUBLE_CLASS;
        if(index==7) return  mxSINGLE_CLASS;
        if(index==8) return  mxINT8_CLASS;
        if(index==9) return  mxUINT8_CLASS;
        if(index==10) return  mxINT16_CLASS;
        if(index==11) return  mxUINT16_CLASS;
        if(index==12) return  mxINT32_CLASS;
        if(index==13) return  mxUINT32_CLASS;
        if(index==14) return  mxINT64_CLASS;
        if(index==15) return  mxUINT64_CLASS;
        if(index==16) return  mxFUNCTION_CLASS;
        assert(0);
    }
    static size_t classID2size(mxClassID& classID){
        //TODO:use SWITCH_CLASSID_numeric
//        int a;
//        decltype(a) v;
//        return sizeof(ClassID2type(classID));
//        return sizeof(ClassID2type(classID));
//        if(classID==mxDOUBLE_CLASS) return sizeof(ClassID2type(classID));
        if(classID==mxDOUBLE_CLASS) return sizeof(double);
        else if(classID==mxSINGLE_CLASS) return sizeof(float);
        else if(classID==mxINT32_CLASS) return sizeof(int);
        else if(classID==mxUINT32_CLASS) return sizeof(unsigned int);
        else if(classID==mxINT16_CLASS) return sizeof(short int);
        else if(classID==mxUINT16_CLASS) return sizeof(unsigned short int);
        else if(classID==mxINT8_CLASS) return sizeof(char);
        else if(classID==mxUINT8_CLASS) return sizeof(unsigned char);
        else if(classID==mxINT64_CLASS) return sizeof(long long);
        else if(classID==mxUINT64_CLASS) return sizeof(unsigned long long);
        else if(classID==mxLOGICAL_CLASS) return sizeof(bool);
        else if(classID==mxCHAR_CLASS) return sizeof(char*);
        else {
            assert(0);
            return sizeof(double);
        }
    }
    static mxClassID getClassID(const type_info& t){
        //mxClassID classID=getClassID(typeid(T));
        //const type_info& t = typeid(T);
        if(t==typeid(double)) return mxDOUBLE_CLASS;
        if(t==typeid(float)) return mxSINGLE_CLASS;
        if(t==typeid(int)) return mxINT32_CLASS;
        if(t==typeid(unsigned int)) return mxUINT32_CLASS;
        if(t==typeid(short int)) return mxINT16_CLASS;
        if(t==typeid(unsigned short int)) return mxUINT16_CLASS;
        if(t==typeid(char)) return mxINT8_CLASS;
        if(t==typeid(unsigned char)) return mxUINT8_CLASS;
        if(t==typeid(bool)) return mxLOGICAL_CLASS;
        if(t==typeid(char*)) return mxCHAR_CLASS;
        if(t==typeid(std::string)) return mxCHAR_CLASS;
        if(t==typeid(long long)) return mxINT64_CLASS;
        if(t==typeid(unsigned long long)) return mxUINT64_CLASS;
//        if(t==typeid(size_t)) return (sizeof(size_t)==sizeof(unsigned long long) ? mxUINT64_CLASS : (sizeof(size_t)==sizeof(unsigned int) ? mxUINT32_CLASS : (assert(0); , mxUINT64_CLASS)));//TODO:see why was needed
        if(t==typeid(size_t)) {
            if(sizeof(size_t)==sizeof(unsigned long long))
                return mxUINT64_CLASS;
            else if(sizeof(size_t)==sizeof(unsigned int))
                return mxUINT32_CLASS;
            else {
                assert(0);
                return mxUINT64_CLASS;
            }
        }
        assert(0);
        return mxUNKNOWN_CLASS;
    }
    static mxClassID getClassID_from_string(char*s){
        if(!strcmp(s, "double")) return mxDOUBLE_CLASS;
        if(!strcmp(s, "single")) return mxSINGLE_CLASS;
        if(!strcmp(s, "int32")) return mxINT32_CLASS;
        if(!strcmp(s, "uint32")) return mxUINT32_CLASS;
        if(!strcmp(s, "uint16")) return mxUINT16_CLASS;
        if(!strcmp(s, "int16")) return mxINT16_CLASS;
        if(!strcmp(s, "uint8")) return mxUINT8_CLASS;
        if(!strcmp(s, "int8")) return mxINT8_CLASS;
        if(!strcmp(s, "logical")) return mxLOGICAL_CLASS;
        if(!strcmp(s, "char")) return mxCHAR_CLASS;
        assert(0);
        return mxUNKNOWN_CLASS;
    }
    static void disp(mxArray*X){
        callMatlab("disp", X);
    }
    
    static void callMatlab(mxArray*&Y1, string command, mxArray*X1){
        const int nlhs=1;
        const int nrhs=1;
        mxArray *plhs[nlhs];
        mxArray *prhs[nrhs];
        prhs[0]=X1;
        int res=mexCallMATLAB(nlhs, plhs, nrhs, prhs, command.c_str());
        assert(res==0);
        Y1=plhs[0];
    }
    static void callMatlab(mxArray*&Y1, string command, mxArray*X1, mxArray*X2){
        const int nlhs=1;
        const int nrhs=2;
        mxArray *plhs[nlhs];
        mxArray *prhs[nrhs];
        prhs[0]=X1;
        prhs[1]=X2;
        int res=mexCallMATLAB(nlhs, plhs, nrhs, prhs, command.c_str());
        assert(res==0);
        Y1=plhs[0];
    }
    static void callMatlab(string command, mxArray*X1){
        const int nlhs=0;
        const int nrhs=1;
        mxArray *plhs[1];//? TODO:LEAK?
        mxArray *prhs[nrhs];
        prhs[0]=X1;
        int res=mexCallMATLAB(nlhs, plhs, nrhs, prhs, command.c_str());
        assert(res==0);
    }
    static void callMatlab(string command){
        const int nlhs=0;
        const int nrhs=0;
        mxArray *plhs[1];//?
        mxArray *prhs[1];//?
        int res=mexCallMATLAB(nlhs, plhs, nrhs, prhs, command.c_str());
        assert(res==0);
    }

	static void assignin(const char*ws,const char*var_name,mxArray*X){
        const int nlhs=0;
        const int nrhs=3;
        mxArray **plhs=NULL;
        mxArray *prhs[nrhs];
        prhs[0]=mxCreateString(ws);
        prhs[1]=mxCreateString(var_name);
        prhs[2]=X;
        int res=mexCallMATLAB(nlhs, plhs, nrhs, prhs, "assignin");
        assert(res==0);
	}

    static void pause(const double time=1e-3) {
        mxArray*A = mxCreateDoubleScalar(time); //TODO:better?
        mexCallMATLAB(0, NULL, 1, &A, "pause");
        mxDestroyArray(A);
    }
    
    static void save2matfile(mxArray *A, string file, string varname){
//TODO:CAUTION:	from http://www.mathworks.com/help/techdoc/apiref/matputvariable.html:	Do not use MATLAB function names for variable names. Common variable names that conflict with function names include i, j, mode, char, size, or path. To determine whether a particular name is associated with a MATLAB function, use the which function.
//        see TEMPSAVE<double>(I1,"I1");
        //mxArray*mxA=array2mxArray(scores);
        //setDimensions(mxA,m,n);
        //save2matfile(mxA,"C:\\tim\\temp\\trash\\1.mat","A");
        
        //matOpen doesn't work under windows unless some library is included
        #if defined(_WIN32)
        assert(0);
        #else
                MATFile *pmat = matOpen(file.c_str(), "w");
        assert(pmat);
        int status = matPutVariable(pmat, varname.c_str(), A);
        assert(!status);
        assert(!matClose(pmat));
        mexPrintf("saved file %s\n", file.c_str());
        #endif
    }
    static mxArray* load2matfile(const char* filepath, const char*  varname){
        #if defined(_WIN32)
        assert(0);
        #else
                MATFile *pmat = matOpen(filepath,"r");
        assert(pmat);
        mxArray*A = matGetVariable(pmat, varname);
        assert(A);
        assert(!matClose(pmat));
        return A;
        #endif
    }
    static void getVariables(const char* filepath,vector<mxArray*>&As){
        #if defined(_WIN32)
        assert(0);
        #else
        MATFile *pmat = matOpen(filepath,"r");
        assert(pmat);
        int num;
        char **names=matGetDir(pmat,&num);
        assert(num>=0);
        As.resize(num);
        for(int i=0;i<num;i++){
//             As[i]=const_cast<mxArray*>(matGetVariable(pmat, names[i]));
            As[i]=matGetVariable(pmat, names[i]);
            assert(As[i]);
        }
        assert(!matClose(pmat));
        #endif
    }
    static void putVariables(const char* filepath,vector<mxArray*>&As,vector<string>&names){
        #if defined(_WIN32)
        assert(0);
        #else
        MATFile *pmat = matOpen(filepath,"w");
        assert(pmat);
        for(int i=0;i<As.size();i++){
//             string name="B";
//             const char*s=names[i];
//             const char*s=name.c_str();
//             int status = matPutVariable(pmat,s, As[i]);
            int status = matPutVariable(pmat,names[i].c_str(), As[i]);
//             int status = matPutVariable(pmat,"A", As[i]);
            assert(!status);
        }
        assert(!matClose(pmat));
        #endif
    }
};

//macros
#define TYPE_mxLOGICAL_CLASS_type bool
#define TYPE_mxDOUBLE_CLASS_type double
#define TYPE_mxSINGLE_CLASS_type float
#define TYPE_mxINT8_CLASS_type char
#define TYPE_mxUINT8_CLASS_type unsigned char
#define TYPE_mxINT16_CLASS_type short int
#define TYPE_mxUINT16_CLASS_type unsigned short int
#define TYPE_mxINT32_CLASS_type int
#define TYPE_mxUINT32_CLASS_type unsigned int
#define TYPE_mxINT64_CLASS long long
#define TYPE_mxUINT64_CLASS unsigned long long

//#define MERGE(A,B)A##B
#define _MERGE(a, b) a ## b
#define MERGE(a, b) _MERGE(a, b)
#define _MERGE3(a, b, c) a ## b ## c
#define MERGE3(a, b, c) _MERGE3(a, b, c)

#define CLASSID2TYPE(classID)JOIN(TYPE_, classID)
//#define CLASSID2TYPE(classID)TYPE_##classID


//TODO:can wrap using same trick as below
#define SWITCH_CLASSID_numeric(classID, fun, expr) \
switch(classID){ \
    case mxLOGICAL_CLASS:{fun<bool>expr break;} \
    case mxDOUBLE_CLASS:{fun<double>expr break;} \
    case mxSINGLE_CLASS:{fun<float>expr break;} \
    case mxINT8_CLASS:{fun<char>expr break;} \
    case mxUINT8_CLASS:{fun<unsigned char>expr break;} \
    case mxINT16_CLASS:{fun<short int>expr break;} \
    case mxUINT16_CLASS:{fun<unsigned short int>expr break;} \
    case mxINT32_CLASS:{fun<int>expr break;} \
    case mxUINT32_CLASS:{fun<unsigned int>expr break;} \
    case mxINT64_CLASS:{fun<long long>expr break;} \
    case mxUINT64_CLASS:{fun<unsigned long long>expr break;} \
    default: assert(0); \
}

#define SWITCH_CLASSID_numeric_no_bool(classID, fun, expr) \
switch(classID){ \
    case mxDOUBLE_CLASS:{fun<double>expr break;} \
    case mxSINGLE_CLASS:{fun<float>expr break;} \
    case mxINT8_CLASS:{fun<char>expr break;} \
    case mxUINT8_CLASS:{fun<unsigned char>expr break;} \
    case mxINT16_CLASS:{fun<short int>expr break;} \
    case mxUINT16_CLASS:{fun<unsigned short int>expr break;} \
    case mxINT32_CLASS:{fun<int>expr break;} \
    case mxUINT32_CLASS:{fun<unsigned int>expr break;} \
    case mxINT64_CLASS:{fun<long long>expr break;} \
    case mxUINT64_CLASS:{fun<unsigned long long>expr break;} \
    default: assert(0); \
}

#define SWITCH_CLASSID_2(classID, fun, expr, c1, c2) \
switch(classID){ \
    case c1:{fun<CLASSID2TYPE(c1)>expr break;} \
    case c2:{fun<CLASSID2TYPE(c2)>expr break;} \
    default: assert(0); \
}
#define SWITCH_CLASSID_3(classID, fun, expr, c1, c2, c3) \
switch(classID){ \
    case c1:{fun<CLASSID2TYPE(c1)>expr break;} \
    case c2:{fun<CLASSID2TYPE(c2)>expr break;} \
    case c3:{fun<CLASSID2TYPE(c3)>expr break;} \
    default: assert(0); \
}
#define SWITCH_CLASSID_4(classID, fun, expr, c1, c2, c3, c4) \
switch(classID){ \
    case c1:{fun<CLASSID2TYPE(c1)>expr break;} \
    case c2:{fun<CLASSID2TYPE(c2)>expr break;} \
    case c3:{fun<CLASSID2TYPE(c3)>expr break;} \
    case c4:{fun<CLASSID2TYPE(c4)>expr break;} \
    default: assert(0); \
}


//        #if #c1 == "mxLOGICAL_CLASS"
//    case c1:{fun<bool>expr break;} \
////        #elseif #c1=="mxLOGICAL_CLASS"
//        #else
//    case c1:{fun<int>expr break;} \
//            #endif

#define STRINGIFY(x) # x
#define XSTRINGIFY(x) STRINGIFY(x)
#define IDENTITY(x)x

#define INVALID_STRING_ERROR(s) mexErrMsgIdAndTxt("MATLAB:error", "invalid string: string='%s', line %d, %s, '%s'\n", s, __LINE__, __func__, __FILE__);

//TODO:simple to do instead arg list as fun("s1",fun1,"s2",fun2,...)
#define SWITCH_STRING(s, fun, expr, ...) \
if(false);\
        MERGE(SWITCH_STRING_, PP_NARG(__VA_ARGS__))(s, fun, expr, __VA_ARGS__)\
        /* else INVALID_STRING_ERROR( s )*/ \
else{\
        int n_args = PP_NARG(__VA_ARGS__); \
        mexPrintf("invalid option: choose from \{", n_args); \
                /*const char* arr[] = { __VA_ARGS__ };*/ \
                const char* arr[] = { MERGE(STRING_ARRAY_, PP_NARG(__VA_ARGS__))(__VA_ARGS__) }; \
                        for(int i = 0; i < n_args; i++) {\
                                mexPrintf("'%s'", arr[i]);\
                                if(i<n_args-1)\
                                        mexPrintf(",");\
                                else\
                                        mexPrintf("}\n");\
                        }\
                        INVALID_STRING_ERROR( s );\
}
//    const char* arr[] = { __VA_ARGS__ }; \ (doesn't work unless inputs are strings

#define _ELSEIF(s, fun, expr, si) \
else if(!strcmp(s, #si)) MERGE(fun, si)IDENTITY(expr)

#define SWITCH_STRING_1(s, fun, expr, si, ...) \
_ELSEIF(s, fun, expr, si)

#define SWITCH_STRING_2(s, fun, expr, si, ...) \
_ELSEIF(s, fun, expr, si)\
        SWITCH_STRING_1(s, fun, expr, __VA_ARGS__)\
        
#define SWITCH_STRING_3(s, fun, expr, si, ...) \
        _ELSEIF(s, fun, expr, si)\
        SWITCH_STRING_2(s, fun, expr, __VA_ARGS__)\
        
#define SWITCH_STRING_4(s, fun, expr, si, ...) \
        _ELSEIF(s, fun, expr, si)\
        SWITCH_STRING_3(s, fun, expr, __VA_ARGS__)\
        
        
#define STRING_ARRAY_4(s, ...) \
        STRINGIFY(s), STRING_ARRAY_3(__VA_ARGS__)
#define STRING_ARRAY_3(s, ...) \
        STRINGIFY(s), STRING_ARRAY_2(__VA_ARGS__)
#define STRING_ARRAY_2(s, ...) \
        STRINGIFY(s), STRING_ARRAY_1(__VA_ARGS__)
#define STRING_ARRAY_1(s, ...) \
        STRINGIFY(s)
