// class Matrix
// Timothee Cour, 30-Sep-2010 01:54:13 -- DO NOT DISTRIBUTE


#pragma once
#include <algorithm>
#include "mex_util.cpp"
#include "vector2.cpp"

//TODO:use size_y instead of int 

//namespace Matrix;
/*
mexGate(nargout, out, nargin, in);
mxClassID classID=mxGetClassID(A);
mxDOUBLE_CLASS
mxArrayToString
Matrix<double>::readmxArray(in[0],vals,-1);
out[0]=Matrix<double>::tomxArray(vals,mxDOUBLE_CLASS,1);
out[0]=Matrix<double>::createmxArray(p,q);
// char*s=mxArrayToString(in[0]);
char*s=getString(in[0]);

out[0]=createStructArray(1);
Matrix<int>::add_field(out[0],"x",A);

const mxArray* Ai;
if(Ai=getFieldByName_if_valid(A,"field"))
Matrix<double>::readmxArray(Ai,field);


mxClassID classID=mxGetClassID(in[0]);
SWITCH_CLASSID_numeric_no_bool(classID,fun,(x1,x2,x3);)

//serialize
    static mxArray* serialize(vector<Point>&points){
        vector<string>fields;
        fields.push_back("score");
        int nb=points.size();
        mxArray *A=createStructArray(nb, fields);
        for(int i=0;i<nb;i++){
            points[i].serialize(A, i);
        }
        return A;
    }
    void serialize(mxArray*A, int i){
        setFieldByName2(A, i, "score", mxCreateDoubleScalar(score));
    }


//deserialize
    static void deserialize(const mxArray*A,vector<Feature_type>&feature_types){
        int nb=mxGetNumberOfElements(A);
        feature_types.resize(nb);
        for(int i=0;i<nb;i++)
            feature_types[i].deserialize(A, i);
    }
        void deserialize(const mxArray*A, int i){
         READ_FIELD2(int,type,A,i,-1)
         READ_FIELD(int,type,A,i)
        }


TODO:

DONE:
support for tomxArray() using _uninitialized... with caution
support better for bool (problem with set,add in *pdata++)
for ex, replace mxBOOL by char, etc
 */

// typedef char bool2;

template<class T> class Matrix {
public:
    int p, q, n;
    vector<T>data;

    Matrix() {
        p = 0;
        q = 0;
        n = 0;
        data.clear();
    }

    Matrix(int p, int q) {
        this->p = p;
        this->q = q;
        n = p*q;
        data.resize(n);
    }

    Matrix(const mxArray *A) {
        readmxArray(A);
    }

    ~Matrix() {
    }

    T & operator[] (const int index) {
        return data[index];
    }

    Matrix<T>& copy() {
        Matrix<T>matrix(p, q);
        //T*pdata=&data[0];
        //T*pdata2=&matrix.data[0];
        //int i=n;
        //while (--i >= 0) *pdata2++ = *pdata++;
        for (int i = 0; i < n; i++)
            matrix.data[i] = data[i];
        return matrix;
    }

    void copy(Matrix<T>&matrix) {
        resize(matrix.p, matrix.q);
        T*pdata = &data[0];
        T*pdata2 = &matrix.data[0];
        int i = n;
        while (--i >= 0) *pdata++ = *pdata2++;
    }

    void read_vector(vector<T>&v) {
        resize(v.size(), 1);
        T*pdata = &data[0];
        T*pdata2 = &v[0];
        int i = n;
        while (--i >= 0) *pdata++ = *pdata2++;
    }

    void resize(int p, int q) {
        this->p = p;
        this->q = q;
        n = p*q;
        data.resize(n);
    }

    void push_back(T& val) {
        n++;
        p++; //assumes column vector
        if (q == 0) {
            q = 1;
        }
        data.push_back(val);
    }

    void erase(typename vector<T>::iterator iter) {
        data.erase(iter);
        n--;
        p--; //assumes column vector
    }

    void add(T val) {
        T*pdata = &data[0];
        int i = n;
        while (--i >= 0) *pdata++ += val;
        //while (--i >= 0) pdata[i] += val;
        /*
        if(val==1)
        while (--i >= 0) ++(*pdata++);
        else if(val==-1)
        while (--i >= 0) --(*pdata++);
        else
        while (--i >= 0) *pdata++ += val;
         */
    }

    void set(T val) {
        T*pdata = &data[0];
        int i = n;
        while (--i >= 0) *pdata++ = val;
    }

    void reset() {
        T*pdata = &data[0];
        int i = n;
        while (--i >= 0) *pdata++ = 0;
    }

    bool isSameSize(Matrix&matrix2) {
        return matrix2.p == p && matrix2.q == q;
    }

    void readmxArray(const mxArray *A) {
        //if A is pAxqAxkA, p=pA,q=qA*kA
        readmxArray(A, data);
        p = mxGetM2(A);
        q = mxGetN2(A);
        n = p*q;
    }

    static T* getData(const mxArray *A) {
        if (mxIsEmpty(A)) {
            T*vals = NULL;
            return vals;
        }
        assert(!mxIsSparse(A));
        mxClassID classID = mxGetClassID(A);
        assert(MatlabInterface::getClassID(typeid (T)) == classID);
        T*vals = (T*) mxGetData(A);
        return vals;
    }

    static T getScalar(const mxArray *A) {//a bit redundant...
        vector<T>data;
        readmxArray(A, data, 0);
        assert(data.size() == 1);
        return data[0];
    }

    static T* getData(const mxArray *A, int&nb) {
        nb = mxGetNumberOfElements(A);
        return getData(A);
    }

    static T* getData(const mxArray *A, int&p, int&q) {
        p = mxGetM(A);
        q = mxGetN(A);
        return getData(A);
    }

    static T* getData(const mxArray *A, int&p, int&q, int&k) {
        getSizes(A, p, q, k);
        return getData(A);
    }

    static void readmxArray(const mxArray *A, vector<T>&data) {
        readmxArray(A, data, 0);
    }

    static void readmxArray(const mxArray *A, vector<T>&data, const T val) {
        mxClassID classID = mxGetClassID(A);
        if (classID == mxLOGICAL_CLASS)
            assert(val == 0);
        SWITCH_CLASSID_numeric(classID, readmxArray_aux, (A, data, val);)
                //        SWITCH_CLASSID_2(classID,readmxArray_aux , (A,data,val); , mxLOGICAL_CLASS,bool,mxDOUBLE_CLASS,double )
                //        SWITCH_CLASSID_3(classID,readmxArray_aux , (A,data,val); , mxLOGICAL_CLASS,mxDOUBLE_CLASS )
    }

    template<class T2>static void readmxArray_aux(const mxArray *A, vector<T>&data, const T val) {
        assert(!mxIsSparse(A));
        int n = mxGetNumberOfElements(A);
        data.resize(n);
        T2 *pA = (T2*) mxGetData(A);
        if (val)
            for (int i = 0; i < n; i++) data[i] = (T) * pA++ + val;
        else
            for (int i = 0; i < n; i++) data[i] = (T) * pA++;
    }
    //for scalar

    static void readmxArray(const mxArray *A, T&data) {
        assert(mxGetNumberOfElements(A) == 1);
        data = (T) mxGetScalar(A);
    }

    static void readmxArray(const mxArray *A, T&data, const T val) {
        assert(mxGetNumberOfElements(A) == 1);
        data = ((T) mxGetScalar(A)) + val;
    }

    mxArray* tomxArray() {
        return tomxArray(MatlabInterface::getClassID(typeid (T)));
    }

    mxArray* tomxArray(mxClassID classID) {
        mxArray*A = tomxArray(data, classID);
        reshape(A, p, q);
        return A;
    }
    //template<>

    static mxArray* tomxArray(vector<T>&v) {
        return tomxArray(v, MatlabInterface::getClassID(typeid (T)));
    }

    static mxArray* tomxArray(T*v,int n) {
        return tomxArray(v, MatlabInterface::getClassID(typeid (T)), 0, n);
    }

    static mxArray* tomxArray(vector<T>&v, mxClassID classID) {
        return tomxArray(v, classID, 0);
    }

    static mxArray* tomxArray(vector<T>&v, mxClassID classID, const T val) {
        return tomxArray(&v[0], classID, val, v.size());
    }

    static mxArray* tomxArray(T*data, mxClassID classID, const T val, int n) {
        //vector<bool> special
        if (classID == mxLOGICAL_CLASS)
            assert(val == 0);
        //		mxArray* A=createmxArray(n,classID);
        mxArray* A = createmxArray_uninitialized(n, classID);
        SWITCH_CLASSID_numeric(classID, tomxArray_aux, (A, data, val, n);)
        return A;
    }

    template<class T2>static void tomxArray_aux(mxArray *A, T*data, const T val, int n) {
        T2 *pA = (T2*) mxGetData(A);
        if (val)
            for (int i = 0; i < n; i++) *pA++ = (T2) (data[i] + val);
        else
            for (int i = 0; i < n; i++) *pA++ = (T2) data[i];
    }

    static mxArray* tomxArray(T& v) {
        //	static mxArray* tomxArray(T v){//problem with string...
        return tomxArray(v, MatlabInterface::getClassID(typeid (T)));
    }

    static mxArray* tomxArray(T& v, mxClassID classID) {
        return tomxArray(v, classID, 0);
    }

    static mxArray* tomxArray(T& v, mxClassID classID, T offset) {
        mxArray *A = createmxArray(1, classID);
        T v2 = v + offset;
        SWITCH_CLASSID_numeric(classID, tomxArray_aux_scalar, (A, v2);)
        return A;
    }

    template<class T2>static void tomxArray_aux_scalar(mxArray *A, T& v) {
        T2 *pA = (T2*) mxGetData(A);
        pA[0] = (T2) v;
    }

    void disp() {
        mxArray *A = tomxArray();
        MatlabInterface::disp(A);
        mxDestroyArray(A);
    }

    void ds() {
        ds(p, q, 1);
        // 		mxArray *A=tomxArray();
        // 		MatlabInterface::callMatlab("ds",A);
        // 		mxDestroyArray(A);
    }

    void ds(int p, int q, int k) {
        ds(data, p, q, k);
        // 		mxArray *A=tomxArray();
        // 		setDimensions(A,p,q,k);
        // 		MatlabInterface::callMatlab("ds",A);
        // 		mxDestroyArray(A);
    }

    static void ds(vector<T>&v, int p, int q, int k) {
        mxArray *A = tomxArray(v);
        setDimensions(A, p, q, k);
        MatlabInterface::callMatlab("ds", A);
        mxDestroyArray(A);
    }

    T sum() {
        T val = 0;
        T*pdata = &data[0];
        int i = n;
        while (--i >= 0) val += *pdata++;
        return val;
    }

    T max() {
        assert(n > 0);
        return *max_element(data.begin(), data.end());
    }

    void transpose() {

        if (p >= 2 && q >= 2) {
            vector<T>dataCopy(data);
            for (int j = 0; j < q; j++) {
                T*pdata = &data[j];
                T*pdataCopy = &dataCopy[j * p];
                for (int i = 0; i < p; i++) {
                    *pdata = *pdataCopy++;
                    pdata += q;
                }
            }
        }
        /*
        if(p>=2 && q>=2){
        T temp;
        for(int j=0;j<q;j++){
        T*pdata1=&data[j*p];
        T*pdata2=&data[j];
        for(int i=j+1;i<p;i++){
        temp=*pdata1;
         *pdata1++ = *pdata2;
         *pdata2=temp;
        pdata2+=p;
        }
        }
        }
         */
        int pold = p;
        p = q;
        q = pold;
    }

    static void disp(vector<T>&v) {
        Matrix<T>matrix;
        matrix.read_vector(v);
        matrix.transpose();
        mxArray *A = matrix.tomxArray();
        MatlabInterface::disp(A);
        mxDestroyArray(A);
    }

    //serialize/deserialize cell

    static void deserialize_cell(const mxArray *A, vector<Matrix<T> >&v) {
        int n = mxGetNumberOfElements(A);
        v.resize(n);
        for (int i = 0; i < n; i++) {
            v[i].readmxArray(mxGetCell(A, i));
        }
    }

    static void deserialize_cell(const mxArray *A, vector<vector<T> >&v, const T val) {
        int n = mxGetNumberOfElements(A);
        v.resize(n);
        for (int i = 0; i < n; i++) {
            Matrix<T>::readmxArray(mxGetCell(A, i), v[i], val);
        }
    }

    static mxArray* serialize_cell(vector<Matrix<T> >&v) {
        return serialize_cell(v, MatlabInterface::getClassID(typeid (T)));
    }

    static mxArray* serialize_cell(vector<Matrix<T> >&v, mxClassID classID) {
        int n = v.size();
        mxArray *A = mxCreateCellMatrix(n, 1);
        for (int i = 0; i < n; i++) {
            mxSetCell(A, i, v[i].tomxArray(classID));
        }
        return A;
    }

    static mxArray* serialize_cell(vector<vector<T> >&v, mxClassID classID, const T val) {
        int n = v.size();
        mxArray *A = mxCreateCellMatrix(n, 1);
        for (int i = 0; i < n; i++) {
            mxSetCell(A, i, Matrix<T>::tomxArray(v[i], classID, val));
        }
        return A;
    }

    static mxArray* serialize_vector_vector(vector<vector<T> >&v) {
        int n = v.size();
        vector<string>fields;
        fields.push_back("pr");
        fields.push_back("jc");
        mxArray*A = createStructArray(1, fields);
        mxArray*A2 = Matrix<int>::createmxArray_uninitialized(n + 1);
        setFieldByName(A, 0, "jc", A2);
        int*jc = Matrix<int>::getData(A2);
        jc[0] = 0;
        int i;
        int nb = 0;
        for (i = 0; i < n; i++) {
            jc[i + 1] = (nb += v[i].size());
        }
        mxArray*A3 = Matrix<T>::createmxArray(nb);
        setFieldByName(A, 0, "pr", A3);
        T*pr = Matrix<T>::getData(A3);
        for (i = 0; i < n; i++) {
            vector<T>&vi = v[i];
            int ni = vi.size();
            for (int j = 0; j < ni; j++) {
                *pr++ = vi[j];
            }
        }
        return A;
    }

    static void deserialize_vector_vector(const mxArray*A, vector<vector<T> >&v) {
        const mxArray*Apr = getFieldByName(A, "pr");
        const mxArray*Ajc = getFieldByName(A, "jc");
        int*jc = Matrix<int>::getData(Ajc);
        T*pr = Matrix<T>::getData(Apr);
        int n = mxGetNumberOfElements(Ajc) - 1;
        int nnz = mxGetNumberOfElements(Apr);
        assert(jc[n] == nnz);
        v.resize(n);

        int nj = jc[0];
        for (int j = 0; j < n; j++) {
            int nj_old = nj;
            nj = jc[j + 1];
            v[j].resize(nj - nj_old);
            for (int i = nj_old; i < nj; i++) {
                v[j][i - nj_old] = pr[i];
            }
        }
    }

    static void getField(const mxArray *A, int i, string field, Matrix<T>&matrix) {
        matrix.readmxArray(getFieldByName(A, i, field));
    }

    static void getField(const mxArray *A, string field, Matrix<T>&matrix) {
        getField(A, 0, field, matrix);
    }

    static mxArray* createmxArray_empty() {
        return createmxArray_empty(MatlabInterface::getClassID(typeid (T)));
    }

    static mxArray* createmxArray_empty(mxClassID classID) {
        int ndim = 2;
        const mwSize dims[] = {(mwSize) 0, (mwSize) 0};
        mxArray *A = mxCreateNumericArray(ndim, dims, classID, mxREAL);
        return A;
    }

    static mxArray* createmxArray(int n) {
        return createmxArray(n, MatlabInterface::getClassID(typeid (T)));
    }

    static mxArray* createmxArray(int n, mxClassID classID) {
        if (n == 0)
            return createmxArray_empty(classID);
        int ndim = 1;
        const mwSize dims[] = {(mwSize) n};
        mxArray *A = mxCreateNumericArray(ndim, dims, classID, mxREAL);
        return A;
    }

    static mxArray* createmxArray(int p, int q) {
        mxClassID classID = MatlabInterface::getClassID(typeid (T));
        int ndim = 2;
        const mwSize dims[] = {(mwSize) p, (mwSize) q};
        mxArray *A = mxCreateNumericArray(ndim, dims, classID, mxREAL);
        return A;
    }

    static mxArray* createmxArray(int p, int q, int k) {
        mxClassID classID = MatlabInterface::getClassID(typeid (T));
        int ndim = 3;
        const mwSize dims[] = {(mwSize) p, (mwSize) q, (mwSize) k};
        mxArray *A = mxCreateNumericArray(ndim, dims, classID, mxREAL);
        return A;
    }

    static mxArray* createmxArray(int p, int q, int k, int r) {
        mxClassID classID = MatlabInterface::getClassID(typeid (T));
        int ndim = 4;
        const mwSize dims[] = {(mwSize) p, (mwSize) q, (mwSize) k, (mwSize) r};
        mxArray *A = mxCreateNumericArray(ndim, dims, classID, mxREAL);
        return A;
    }

    static mxArray* createmxArray(int p1, int p2, int p3, int p4, int p5) {
        mxClassID classID = MatlabInterface::getClassID(typeid (T));
        mxArray*A = createmxArray(p1 * p2 * p3 * p4*p5, classID);
        reshape(A, p1, p2, p3, p4, p5);
        return A;
    }

    //     static mxArray* createmxArray_sparse(int p,int q,vector<int>&indi,vector<int>&indj,vector<T>&valij){
    //         mxClassID classID=MatlabInterface::getClassID(typeid(T));
    //         int ndim=3;
    // 		const mwSize dims[]={(mwSize)p,(mwSize)q,(mwSize)k};
    //         mxArray *A=mxCreateNumericArray(ndim,dims,classID,mxREAL);
    //         return A;
    //     }

    static mxArray* createmxArray_uninitialized(int n) {
        return createmxArray_uninitialized(n, MatlabInterface::getClassID(typeid (T)));
    }

    static mxArray* createmxArray_uninitialized(int n, mxClassID classID) {
        if (n == 0)
            return createmxArray_empty(classID);
        int ndim = 1;
        const mwSize dims[] = {(mwSize) 0};
        mxArray *A = mxCreateNumericArray(ndim, dims, classID, mxREAL);
        void*data = mxGetData(A);
        data = mxRealloc(data, n * MatlabInterface::classID2size(classID));
        mxSetData(A, data);

        int ndim2 = 1;
        const mwSize dims2[] = {(mwSize) n};
        mxSetDimensions(A, dims2, ndim2);
        return A;
    }

    static mxArray* createmxArray_uninitialized(int p, int q) {
        mxArray*A = createmxArray_uninitialized(p * q);
        reshape(A, p, q);
        return A;
    }

    static mxArray* createmxArray_uninitialized(int p, int q, int k) {
        mxArray*A = createmxArray_uninitialized(p * q * k);
        reshape(A, p, q, k);
        return A;
    }

    static mxArray* createmxArray_uninitialized(int p, int q, int k, int r) {
        mxArray*A = createmxArray_uninitialized(p * q * k * r);
        reshape(A, p, q, k, r);
        return A;
    }

    static mxArray* createmxArray_uninitialized(int p1, int p2, int p3, int p4, int p5) {
        mxArray*A = createmxArray_uninitialized(p1 * p2 * p3 * p4 * p5);
        reshape(A, p1, p2, p3, p4, p5);
        return A;
    }

    static void reshape(mxArray*A, int p, int q) {
        int n = mxGetNumberOfElements(A);
        assert(p * q == n);
        int ndim = 2;
        const mwSize dims[] = {(mwSize) p, (mwSize) q};
        mxSetDimensions(A, dims, ndim);
    }

    static void reshape(mxArray*A, int p, int q, int k) {
        int n = mxGetNumberOfElements(A);
        assert(p * q * k == n);
        int ndim = 3;
        const mwSize dims[] = {(mwSize) p, (mwSize) q, (mwSize) k};
        mxSetDimensions(A, dims, ndim);
    }

    static void reshape(mxArray*A, int p, int q, int k, int r) {
        int n = mxGetNumberOfElements(A);
        assert(p * q * k * r == n);
        int ndim = 4;
        const mwSize dims[] = {(mwSize) p, (mwSize) q, (mwSize) k, (mwSize) r};
        mxSetDimensions(A, dims, ndim);
    }

    static void reshape(mxArray*A, int p1, int p2, int p3, int p4, int p5) {
        int n = mxGetNumberOfElements(A);
        assert(p1 * p2 * p3 * p4 * p5 == n);
        int ndim = 5;
        const mwSize dims[] = {(mwSize) p1, (mwSize) p2, (mwSize) p3, (mwSize) p4, (mwSize) p5};
        mxSetDimensions(A, dims, ndim);
    }

    static void reshape(mxArray*A, vector<mwSize>&dims_elmt) {
        int n = mxGetNumberOfElements(A);
        int n2 = 1;
        for (int i = 0; i < dims_elmt.size(); i++) {
            n2 *= dims_elmt[i];
        }
        assert(n2 == n);
        //        int ndim=dims_elmt.size();
        //		const mwSize dims[]={(mwSize)p1,(mwSize)p2,(mwSize)p3,(mwSize)p4,(mwSize)p5};
        mxSetDimensions(A, &dims_elmt[0], dims_elmt.size());
    }

    static int add_field(mxArray*A, const char*name, vector<T>& val) {
        int field_number = mxAddField(A, name);
        mxSetFieldByNumber(A, 0, field_number, Matrix<T>::tomxArray(val));
        return field_number;
    }

    static int add_field(mxArray*A, const char*name, T& val) {
        int field_number = mxAddField(A, name);
        mxSetFieldByNumber(A, 0, field_number, Matrix<T>::tomxArray(val));
        return field_number;
    }

    static int add_field(mxArray*A, const char*name, mxArray*Af) {
        int field_number = mxAddField(A, name);
        mxSetFieldByNumber(A, 0, field_number, Af);
        return field_number;
    }

    static void set(vector<T>&vals, const T val) {
        set(&vals[0], vals.size(), val);
    }

    static inline void set(T*vals, int n, const T val) {
        for (int i = 0; i < n; i++)
            vals[i] = val;
    }

    template<class T2>static void tomxArray_aux_bool(mxArray *A, vector<bool>&v, const bool val) {
        int n = v.size();
        T2 *pA = (T2*) mxGetData(A);
        if (val)
            for (int i = 0; i < n; i++) *pA++ = (T2) (v[i] + val); //TODO:allow this for bool?
        else
            for (int i = 0; i < n; i++) *pA++ = (T2) v[i];
    }

    static mxArray*tomxArray_nocopy(T* x, int n) {
        //caution:caller shouldn't free x
        return tomxArray_nocopy(x, n, MatlabInterface::getClassID(typeid (T)));
    }

    static mxArray*tomxArray_nocopy(T* x, int n, mxClassID classID) {
        //caution:caller shouldn't free x
        assert(sizeof (T) == MatlabInterface::classID2size(classID));
        mwSize ndim = 1;
        const mwSize dims[] = {(mwSize) 0};
        mxArray *A = mxCreateNumericArray(ndim, dims, classID, mxREAL);
        mxFree(mxGetData(A));
        mxSetData(A, x);
        const mwSize dims2[] = {(mwSize) n};
        mxSetDimensions(A, dims2, ndim);
        return A;
    }

    static mxArray*tomxArray_nocopy(vector2<T>&x) {
        //caution:caller shouldn't modify x now...
        return tomxArray_nocopy(x, MatlabInterface::getClassID(typeid (T)));
    }

    static mxArray*tomxArray_nocopy(vector2<T>&x, mxClassID classID) {
        //caution:caller shouldn't modify x now...
        x.set_persistent();
        return tomxArray_nocopy(x.begin(), x.size(), classID);
    }

    static void mxArray2scalars(const mxArray*A,T& x0,T&x1){
	vector<T>x;
	Matrix<T>::readmxArray(A,x);
	assert(x.size()==2);
	x0=x[0];
	x1=x[1];
    }
    static void mxArray2scalars(const mxArray*A,T& x0,T&x1,T&x2){
	vector<T>x;
	Matrix<T>::readmxArray(A,x);
	assert(x.size()==3);
	x0=x[0];
	x1=x[1];
	x2=x[2];
    }
    static void mxArray2scalars(const mxArray*A,T& x0,T&x1,T&x2,T&x3){
	vector<T>x;
	Matrix<T>::readmxArray(A,x);
	assert(x.size()==4);
	x0=x[0];
	x1=x[1];
	x2=x[2];
	x3=x[3];
    }

};

//template specializations

template <>mxArray* Matrix<string>::tomxArray(string&v, mxClassID classID) {
    if (classID == mxCHAR_CLASS)
        return mxCreateString(v.c_str());
    assert(0);
    return NULL;
}

template <>mxArray* Matrix<char*>::tomxArray(char* &v, mxClassID classID) {
    if (classID == mxCHAR_CLASS)
        return mxCreateString(v);
    assert(0);
    return NULL;
}

template <>mxArray* Matrix<bool>::tomxArray(vector<bool>&v, mxClassID classID, const bool val) {
    //vector<bool> special
    if (classID == mxLOGICAL_CLASS)
        assert(val == 0);
    int n = v.size();
    //    mxArray *A=createmxArray(n,classID);
    mxArray* A = createmxArray_uninitialized(n, classID);
    SWITCH_CLASSID_numeric(classID, tomxArray_aux_bool, (A, v, val);)
    return A;
}

template <>void Matrix<bool>::set(vector<bool>&vals, const bool val) {
    int n = vals.size();
    for (int i = 0; i < n; i++)
        vals[i] = val;
}

/*
template<>void Matrix<bool>::set(bool val){
    for(int i=0;i<n;i++){
        data[i]=val;
    }
}
template<>bool& Matrix<bool>::operator[] (const int index){
    return data[index];
}
 */

mxArray* submxArray(const mxArray*A, int start, int nb, vector<mwSize>&dims_elmt) {
    //TODO:uninitialized...
    mxClassID classID = mxGetClassID(A);
    mxArray*si = mxCreateNumericArray(dims_elmt.size(), &dims_elmt[0], classID, mxREAL);
    size_t size_val = MatlabInterface::classID2size(classID);
    void*pr = mxGetData(si);
    unsigned char*pr0 = (unsigned char*) mxGetData(A); //TODO:ok?
    memcpy(pr, pr0 + start*size_val, nb * size_val);
    return si;
}

//serialize/deserialize vectors to/from matlab

template<typename T>mxArray*serialize_vector(vector<T>&t) {
    const char** fields = T::fields;
    int nb_fields = T::nb_fields;
    int nb = t.size();
    mxArray *A = createStructArray(nb, fields, nb_fields);
    for (int i = 0; i < nb; i++) {
        t[i].serialize(A, i);
    }
    return A;
}

template<typename T>void deserialize_vector(const mxArray*A, vector<T>&t) {
    int nb = mxGetNumberOfElements(A);
    t.resize(nb);
    for (int i = 0; i < nb; i++)
        t[i].deserialize(A, i);
}


//serialize/deserialize objects

template<class T>mxArray*serialize_object(T*obj) {
    assert(obj);
    //    return mxCreateDoubleScalar((unsigned long int)obj);
    //    return mxCreateDoubleScalar((size_t)obj);
    size_t ptr = (size_t) (obj);
    return Matrix<size_t>::tomxArray(ptr);
}

template<class T>void serialize_object(mxArray*A, char*s, T*obj) {
    //    Matrix<unsigned long int>::add_field(A,s,serialize_object<T>(obj));
    Matrix<size_t>::add_field(A, s, serialize_object<T > (obj));
}

template<class T>T*deserialize_object(const mxArray*A) {
    int nb = A ? mxGetNumberOfElements(A) : 0;
    if (nb == 0)
        return NULL;

    size_t px = mxGetScalar(A);
    //    size_t px=(size_t)(*mxGetData(A));
    //    size_t px=mxGetScalar(A);
    if (px) {
        assert(MatlabInterface::getClassID(typeid (size_t)) == mxGetClassID(A));
        return (T*) px;
    } else
        return NULL;
}

template<class T>T*deserialize_object(const mxArray*A, char*s) {
    mxArray*Ai = getFieldByName(A, s);
    return deserialize_object<T > (Ai);
}

template<class T>void release_object(const mxArray*A) {
    T*obj = deserialize_object<T > (A);
    assert(obj);
    delete obj;
}

template<class T>void release_object(const mxArray*A, char*s) {
    const mxArray*Ai = getFieldByName(A, s);
    release_object<T > (Ai);
}
//template<class T>void release_objects(const mxArray*A){//cannot do unless we know types...
//    assert(mxIsStruct(A));
//    int nb=mxGetNumberOfFields(A);
//    for(int i=0;i<nb;i++){
//        const mxArray*Ai=mxGetFieldByNumber(A,0,i);
//        release_object<T>(Ai);
//    }
//}







//TODO:move out or clean up

void TEMPSAVE(string name,mxArray*X) {
    //string filepath_save_trash="C:\\tim\\temp\\trash\\";
    string filepath_save_trash = "/Users/timothee/temp/matlab/from_mex/";//TODO:move out of here; make sure exists
    MatlabInterface::save2matfile(X, filepath_save_trash + name + ".mat", name);
//	MatlabInterface::assignin("caller",name.c_str(),X);
}

template<typename T>
void TEMPSAVE(string name,T*v,  int p, int q) {
    //TEMPSAVE<double>(v,"A",p,q);
    mxArray*mxA = Matrix<T>::tomxArray(v,p*q);
    setDimensions(mxA, p, q);
    TEMPSAVE(name,mxA);
    mxDestroyArray(mxA);
}

template<typename T>
void TEMPSAVE(string name,T*v,  int p, int q, int k) {
    //TEMPSAVE<double>(v,"A",p,q,k);
    mxArray*mxA = Matrix<T>::tomxArray(v,p*q*k);
    setDimensions(mxA, p, q, k);
    TEMPSAVE(name,mxA);
    mxDestroyArray(mxA);
}

template<typename T>
void TEMPSAVE(string name,T*v, int n) {
    //TEMPSAVE<double>(v,"A");
    mxArray*mxA = Matrix<T>::tomxArray(v,n);
    TEMPSAVE(name,mxA);
    mxDestroyArray(mxA);
}
template<typename T>
void TEMPSAVE(string name,T&v) {
	TEMPSAVE<T>(name,&v[0], v.size());
}
//TODO:how could it even work??
#define TEMPSAVE(X) TEMPSAVE(#X,X)

template<typename T, typename T2>
inline void readfield(const char*field, const mxArray*A, T2& var, int i = 0, const T val = 0) {
    Matrix<T>::readmxArray(getFieldByName2(A, i, field), var, val);
}

//TODO:cleanup
/*
 *READFIELD(var, A);
 *READFIELD(var, A,i);
 *READFIELD(var, A,i,1);
 */
#define WRITE_FIELD(type, field, A, i) setFieldByName2(A, i, #field, Matrix<type>::tomxArray(field));
#define WRITE_FIELD2(type, field, A, i, classID) setFieldByName2(A, i, #field, Matrix<type>::tomxArray(field, classID));
#define WRITE_FIELD3(type, field, A, i, classID, offset) setFieldByName2(A, i, #field, Matrix<type>::tomxArray(field, classID, offset));
#define WRITE_FIELD_nocopy(type, field, A, i) setFieldByName2(A, i, #field, Matrix<type>::tomxArray_nocopy(field));

#define READ_FIELD(type, field, A, i) do{Matrix<type >::readmxArray(getFieldByName2(A, i, #field), field);}while(false)
#define READ_FIELD2(type, field, A, i, offset) do{Matrix<type >::readmxArray(getFieldByName2(A, i, #field), field, offset);}while(false)

#define READFIELD(field, A,...)\
do{ \
    readfield < typeof(field[0]) , typeof(field) >\
        (#field,A,field,##__VA_ARGS__); \
}while(false)

#define READSCALAR(field, A,...)\
do{ \
    readfield < typeof(field) , typeof(field) >\
        (#field,A,field,##__VA_ARGS__); \
}while(false)

