// class MatrixOp
// Timothee Cour, 30-Sep-2010 01:54:13 -- DO NOT DISTRIBUTE

#include "Matrix.cpp"

#pragma once

template<class T> class MatrixOp {
public:

    inline static int round(T val) {
        return (int) (val + 0.5);
    }

    inline static T ceil_div_integer(T x, T y) {
        return (x + y - 1) / y;
    }

    static void swap(T&x, T&y) {
        T z = x;
        x = y;
        y = z;
    }

    static void find(vector<T>A, vector<int>&v) {
        v.clear();
        for (int i = 0; i < A.size(); i++) {
            if (A[i]) {
                v.push_back(i);
            }
        }
    }

    static bool ismember(T& val, vector<T>&v) {
        for (int i = 0; i < v.size(); i++) {
            if (v[i] == val)
                return true;
        }
        return false;
    }

    static void find_val(vector<T>A, vector<int>&v, T val) {
        v.clear();
        for (int i = 0; i < A.size(); i++) {
            if (A[i] == val) {
                v.push_back(i);
            }
        }
    }

    static void cat(vector<T>&v1, vector<T>&v2, vector<T>&v3) {
        int n1 = v1.size();
        int n2 = v2.size();
        int n3 = n1 + n2;
        v3.resize(n3);
        int i;
        for (i = 0; i < n1; i++)
            v3[i] = v1[i];
        for (i = 0; i < n2; i++)
            v3[i + n1] = v2[i];
    }

    static void cat(vector<T>&v1, vector<T>&v2) {
        int n1 = v1.size();
        int n2 = v2.size();
        v1.resize(n1 + n2);
        for (int i = 0; i < n2; i++)
            v1[i + n1] = v2[i];
    }

    static void cats(vector<vector<T> >&vs, vector<T>&v) {
        int nv = vs.size();
        int n = 0;
        for (int j = 0; j < nv; j++) {
            n += vs[j].size();
        }
        v.resize(n);
        int itot = 0;
        for (int j = 0; j < nv; j++) {
            for (int i = 0; i < vs[j].size(); i++, itot++) {
                v[itot] = vs[j][i];
            }
        }
    }

    static void subMatrix(Matrix<T>&A, Matrix<T>&AS, vector<int>&ind1, vector<int>&ind2) {
        int n1 = A.p;
        int n2 = A.q;
        int nS1 = ind1.size();
        int nS2 = ind2.size();
        AS.resize(nS1, nS2);
        int k = 0;
        for (int j = 0; j < nS2; j++) {
            int j2 = ind2[j] * n1;
            for (int i = 0; i < nS1; i++, k++) {
                AS[k] = A[ind1[i] + j2];
            }
        }

    }

    static void enumerate_cartesian_product(vector<int>&dims, vector<vector<int> >&indexes) {
        int d = 1;
        int i, j;
        int nD = dims.size();
        for (j = 0; j < nD; j++) {
            d *= dims[j];
        }
        indexes.resize(d);
        for (i = 0; i < d; i++) {
            indexes[i].resize(nD);
            int nDi = 1;
            for (j = 0; j < nD; j++) {
                indexes[i][j] = (i / nDi) % dims[j];
                nDi *= dims[j];
            }
        }
    }

    static void enumerate_sub_sums(vector<int>&dims, int K, vector<vector<int> >&indexes) {
        int d = 1;
        int i, j;
        int nD = dims.size();
        for (j = 0; j < nD; j++) {
            d *= dims[j];
        }
        vector<int>indexesi(nD);
        for (i = 0; i < d; i++) {
            int nDi = 1;
            int sumi = 0;
            for (j = 0; j < nD; j++) {
                indexesi[j] = (i / nDi) % dims[j];
                nDi *= dims[j];
                sumi += indexesi[j];
            }
            if (sumi == K) {
                indexes.push_back(indexesi);
            }
        }
    }

    static T max(T*v, int n) {
        assert(n > 0);
        T val = v[0];
        T temp;
        for (int i = 1; i < n; i++)
            if ((temp = v[i]) > val)
                val = temp;
        return val;
    }

    static T min(T*v, int n) {
        assert(n > 0);
        T val = v[0];
        T temp;
        for (int i = 1; i < n; i++)
            if ((temp = v[i]) < val)
                val = temp;
        return val;
    }

    static void max(T*v, int n, T&val, int&ind) {
        assert(n > 0);
        ind = 0;
        val = v[0];
        T temp;
        for (int i = 1; i < n; i++)
            if ((temp = v[i]) > val) {
                val = temp;
                ind = i;
            }
    }

    static void min(T*v, int n, T&val, int&ind) {
        assert(n > 0);
        ind = 0;
        val = v[0];
        T temp;
        for (int i = 1; i < n; i++)
            if ((temp = v[i]) < val) {
                val = temp;
                ind = i;
            }
    }

    static T min(vector<T>&v) {
        return min(&v[0], v.size());
    }

    static inline T max(T v1, T v2) {
        return (v2 <= v1 ? v1 : v2);
    }

    static T min(T v1, T v2) {
        return (v2 <= v1 ? v2 : v1);
    }

    static T max(vector<T>&v) {
        return max(&v[0], v.size());
    }

    static T sum(vector<T>&v) {//TODO:uniformize...
        T val = 0;
        int n = v.size();
        for (int i = 0; i < n; i++) {
            val += v[i];
        }
        return val;
    }
    static T sum(T*v,int n) {//TODO:uniformize...
        T val = 0;
        for (int i = 0; i < n; i++) {
            val += v[i];
        }
        return val;
    }

    static void add(vector<T>&v, T val) {
        int n = v.size();
        for (int i = 0; i < n; i++) {
            v[i] += val;
        }
    }

    static T mean(vector<T>&v) {
        T val = sum(v);
        int n = v.size();
        if (n != 0)
            val /= n;
        return val;
    }

    static T dot(vector<T>&v1, vector<T>&v2) {
        return dot(&v1[0], &v2[0], v1.size());
    }

    static T dot(T*v1, T*v2, int n) {
        T val = 0;
        for (int i = 0; i < n; i++) {
            val += v1[i] * v2[i];
        }
        return val;
    }

    static T norm2_2(T*v1, int n) {
        T val = 0;
        for (int i = 0; i < n; i++) {
            val += v1[i] * v1[i];
        }
        return val;
    }

    static void randintpair_sorted(int p, int &x1, int &x2) {
        x1 = rand() % p;
        x2 = rand() % (p - 1);
        if (x2 >= x1) {
            x2++;
        } else {
            int temp = x1;
            x1 = x2;
            x2 = temp;
        }
    }

    static void to_cumsum(T*counts, int n, bool is_ordered) {
        T temp = 0;
        if (is_ordered) {
            for (int i = 0; i < n; i++)
                counts[i] = (temp += counts[i]);
        } else {
            for (int i = n - 1; i >= 0; i--)
                counts[i] = (temp += counts[i]);
        }
    }
    //    static void correlation2d(T*counts,int n,bool is_ordered){
    //    }
};

