function filesError = compileFiles(filepaths,mode);
% Timothee Cour, 30-Sep-2010 01:54:13 -- DO NOT DISTRIBUTE

if nargin<2
    mode=[];
end

files=filepaths2files(filepaths);

dir_old=pwd;
n_old=length(dir_old);
for i=1:length(files)
    temp=files(i).filepath;
    if length(temp)>=n_old && strcmp(temp(1:n_old),dir_old)
        temp=temp(n_old+1:end);
    end
    files(i).filepathrel=temp;
end

mex_exts={'.cpp','.c'};
ind=find(strcmp({files.ext},mex_exts{1}) | strcmp({files.ext},mex_exts{2}));
files=files(ind);
isValid=isRealMexFiles({files.filepath});
files=files(isValid==1);

if 1
    funs=dependency_funs;
    isValid2=funs.compute_is_mex_outdated_all({files.filepath},mode);
%     isValid2=~compute_is_compiled({files.filepath});
    files=files(isValid2==1);
end

disp('files to compile:');
dispStrings2({files.filepath},1);

result=compileFiles_aux(files);

filesError=result([result.isError]==1);
filesCompiled=result([result.isError]==0);
disp([sprintf('\n'),'There were ' num2str(length(filesCompiled)) ' files compiled']);
for i=1:length(filesCompiled)
    disp(filesCompiled(i).file.filepathrel);
end


nErrors=length(filesError);
if nErrors > 0
    disp([sprintf('\n'),'Error: There were ' num2str(nErrors) ' erroneous files during compilation']);
    for i=1:nErrors
        disp(filesError(i).file.filepathrel);
    end
else
    disp([sprintf('\n'),'Compilation of files succeded without error ']);%TODO: #files compiled
end
if nargout==0 && isempty(filesError)
    clear filesError;
end

function result=compileFiles_aux(files);
for i=1:length(files)
    result(i)=compileFile(files(i),i,length(files));
end
if isempty(files)
    result=emptyStruct({'isError'});
end

function result=compileFile(file,index_files,nb_files);
[result.isErrorDuringCompilation,result.isCompilationFailed,result.message,result.compiledFilename]=compileFile_aux(file);
result.file=file;
result.isError=result.isErrorDuringCompilation || result.isCompilationFailed;
if result.isErrorDuringCompilation
    warning(['Error: uncaught error during compilation of ' file.filepathrel,' : ',result.message]);
else
    if result.isCompilationFailed
        disp('*********************************');
%         disp(['Error: compilation of ' file.filepathrel,' failed',' : ',result.message]);
        disp(['Error: compilation of ' file.filepathrel,' failed',' :\n',result.message]);
        dispProgress(index_files,nb_files,['error with ' file.filepathrel]);
    else
        if ~isempty(result.compiledFilename)
%             disp(['compiled ' file.filepathrel,' => ',result.compiledFilename]);
            dispProgress(index_files,nb_files,['compiled ' file.filepathrel,' => ',result.compiledFilename]);
        end
    end
end

function [isErrorDuringCompilation,isCompilationFailed,message,compiledFilename]=compileFile_aux(file);
isErrorDuringCompilation=0;
isCompilationFailed=0;
message='';
compiledFilename='';


try
    if ispc
        [isCompilationFailed,message]=mex_aux(file.name,file.path);
    else
        [isCompilationFailed,message]=mex_aux(file.name,file.path);
    end
    if ~isCompilationFailed
        compiledFilename=changeExt(file.name,['.',mexext]);
    else
        isCompilationFailed=1;
    end
catch
    isErrorDuringCompilation=1;
    message=lasterr;    
end


function isMexfiles=isRealMexFiles(filepaths);
for i=1:length(filepaths)
    isMexfiles(i)=isRealMexFile(filepaths{i});
end

function isMexfile=isRealMexFile(filepath);
%TODO:do regexp to capture isolated word only
string=file2string(filepath);
isMexfile=any(strfind(string,'mexFunction'));

% sourceCode = textread(filepath,'%s','delimiter','\n','whitespace','');
% temp = strfind(sourceCode,'mexFunction');
% occurences = 0;
% for i=1:length(temp)
%     occurences = occurences + length(temp{i});
% end
% isMexfile=occurences>0;
