function listFiles=computeIncludeDependencies(files);
% Timothee Cour, 30-Sep-2010 01:54:13 -- DO NOT DISTRIBUTE

if isempty(files)
    listFiles=[];
    return;
end

if ischar(files)
    files={files};
end
if iscell(files)
    temp=files;
    clear files
    for i=1:length(temp)
        files(i).filepath=temp{i};
    end    
end

dirInput=pwd;
files_present=compute_c_files(dirInput);

queueFiles=files_present([]);%explore #include in those files
for i=1:length(files)
    queueFiles(i).filepath=files(i).filepath;
end
listFiles=[];%set of files to include

% isChanged=true;
while ~isempty(queueFiles)
    file=queueFiles(1);
    queueFiles=queueFiles(2:end);
    [listFiles,queueFiles]=updateListFiles(file,listFiles,queueFiles,files_present);
end

% for i=1:length(listFiles)
%     disp(listFiles(i).filepath);
% end


function [listFiles,queueFiles]=updateListFiles(file,listFiles,queueFiles,files_present);
% isChanged=0;
files0=dependency_funs.computeIncludeFiles(file.filepath);

for i=1:length(files0)
    [isValid,fileInclude_i]=compute_isValid_include_file(files0(i),files_present);
    if isValid
        [listFiles,isChanged_i]=addNewFile(fileInclude_i,listFiles);
        if isChanged_i
            queueFiles(end+1)=fileInclude_i;
%             queueFiles(end+1)=fileInclude_i.filepath;
        end
    end
end



function [listFiles,isChanged]=addNewFile(file,listFiles);
isChanged=0;
if isempty(listFiles)
    listFiles=file;
    isChanged=1;
    return;
end
if ~any(strcmp(file.filepath,{listFiles.filepath}))
    listFiles(end+1)=file;
    isChanged=1;
end

function files=compute_c_files(dirInput);
res=ext_funs.compute_exts();
c_exts=res.ext_source_C;
for i=1:length(c_exts)
    c_exts{i}=['*',c_exts{i}];
end
% c_exts={'*.cpp','*.c','*.h'};
files=find_files(pwd,c_exts,'r');
0;

function [isValid,fileInclude]=compute_isValid_include_file(fileInclude0,files_present);
isValid=0;
fileInclude=[];

% [path,name,ext]=fileparts(fileInclude0.fileInclude);
% names={files_present.name0};

[path,name,ext]=fileparts(fileInclude0.filepath);
name=[name,ext];
names={files_present.name};

ind=find(strcmp(name,names));
if isempty(ind)
    return;
end
if length(ind)>1
    disp(['multiple files with same name: ',fileInclude0.filepath,' ',cat_strings({files_present(ind).filepath},' , ')]);%TODO:handle
    return;
end

isValid=1;
fileInclude=files_present(ind);



