function bags=compute_bags_from_labels_bag_2(labels_bag,W,options0);
% bags=[];
% Timothee Cour, 30-Sep-2010 01:54:13 -- DO NOT DISTRIBUTE

[n,nbLabels]=size(labels_bag);

% options.is_sparse_bags=0;%PARAM
options.is_sparse_bags=0;%PARAM
options.is_naive=0;%PARAM (much worse)
options.is_balance=1;%PARAM (seems better)
options.is_symmetric_loss_bags=0;%PARAM (seems better with 0?)
options.is_contrastive=0;
options.is_supervised=0;

options.is_mean=0;%PARAM (worse except when we have W)
% options.is_mean=options.is_W;%PARAM (worse except when we have W)

if nargin>=3
    options=getOptions(options,options0);
end
options.is_W=nargin>=2 && ~isempty(W);

load_fields(options);

labels_bag=compute_negative_bags(labels_bag,is_sparse_bags);

loss_string='exp';
% loss_string='log';
% loss_string='square';

is_constraint_labels=0;%TODO

%TODO:if positive bag size 1, don't do cup
bags=cell(n,1);
for i=1:n
    %% positive bags
    bagsi=[];
    
    is_supervised_bag=sum(labels_bag(i,:)==1)==1;
    if ~is_naive && ~is_contrastive && (~options.is_supervised || is_supervised_bag)
%     if ~is_naive 
        ind=find(labels_bag(i,:)==1);
        nind=length(ind);
        temp=ones(1,nind);
        bag.indexes=i*temp;
        bag.labels=ind;
        if is_mean
            bag.coeffs=1*temp/nind;            
%             bag.coeffs=1*temp/(nind*32); %TODO:interesting idea;
%             might work
        else
            bag.coeffs=temp;
        end
        bag.y_bag=1;
        
        bag.is_symmetric=is_symmetric_loss_bags & nind>1;

        bag.offset=0;%PARAM      
%         bag.offset=-(nind-1); %works a bit better it seems
%         bag.offset=(nind-1);
        %{
        if is_mean
            bag.offset=2*(nind-1)/nind;
%             bag.offset=-2*(nind-1)/nind;
        else
%             bag.offset=nind-1;
            bag.offset=-(nind-1);
        end
        %}
        
%         if is_symmetric_loss_bags & length(ind)>1
%             bag.loss_string='exp_sensitive';
%         else
%             bag.loss_string=loss_string;
%         end
        
        bagsi=[bagsi;bag];
        
        if 0
            bag.is_symmetric=0;
%             bag.loss_string='exp_sensitive';
            bagsi=[bagsi;bag];
        end
        
        
%     else %naive model
    elseif ~is_contrastive && options.is_naive 
        ind=find(labels_bag(i,:)==1);
        for j=1:length(ind)
            bag.indexes=i;
            bag.labels=ind(j);
            bag.coeffs=1;
            bag.y_bag=1;
%             bag.loss_string=loss_string;
            bag.is_symmetric=0;
            bag.offset=0;
            bagsi=[bagsi;bag];
        end
    end

    %% negative bags
    if 0 %single negative bag
        ind=find(labels_bag(i,:)==-1);
        temp=ones(size(ind));
        bag.indexes=i*temp;
        bag.labels=ind;
        bag.coeffs=-1*temp;
        bag.y_bag=-1;
%         bag.loss_string=loss_string;
        bag.is_symmetric=0;
        bag.offset=0;%PARAM
        bagsi=[bagsi;bag];
    end
    
    
    if is_contrastive
        indpos=find(labels_bag(i,:)==1);
        ni=length(indpos);
        ind=find(labels_bag(i,:)==-1);        
        clear bagstemp
        for j=length(ind):-1:1
            bagstemp(j).indexes=[i,i*ones(1,ni)];
            bagstemp(j).labels=[ind(j),indpos];
            bagstemp(j).coeffs=[-1,ones(1,ni)/ni];
            bagstemp(j).y_bag=1;
%             bagstemp(j).loss_string=loss_string;
            bagstemp(j).is_symmetric=0;
            bagstemp(j).offset=0;%PARAM
%             bagsi=[bagsi;bag];
        end
        if ~isempty(ind)
            bagsi=[bagsi;bagstemp(:)];
        end
    end

    if ~is_contrastive && (~options.is_supervised || is_supervised_bag)
%     if 1
        ind=find(labels_bag(i,:)==-1);        
        clear bagstemp
        for j=length(ind):-1:1
            bagstemp(j).indexes=i;
            bagstemp(j).labels=ind(j);
            bagstemp(j).coeffs=-1;
            bagstemp(j).y_bag=-1;
%             bagstemp(j).loss_string=loss_string;
            bagstemp(j).is_symmetric=0;
            bagstemp(j).offset=0;
%             bagsi=[bagsi;bag];
        end
        if ~isempty(ind)
            bagsi=[bagsi;bagstemp(:)];
        end
    end
    
    if is_constraint_labels
        ind=(1:size(labels_bag,2))';
        nind=length(ind);
        temp=ones(1,nind);
        bag.indexes=i*temp;
        bag.labels=ind;
        bag.coeffs=temp;
        bag.y_bag=0;        
        bag.is_symmetric=1;
        bag.offset=nind-2;        
        bagsi=[bagsi;bag];
    end

    bags{i}=bagsi;
end

bags=cat(1,bags{:});

if is_balance
    bagstemp=compute_bag_balances(labels_bag,loss_string);
    bags=[bags;bagstemp];
end

% offset_W=0;%seems best when constraints are true
offset_W=2; %seems best when constraints are not all true
% offset_W=1.5; 

if is_W
%     [indi,indj,valij]=find(tril(W));
    [indi,indj,valij]=find(W);
    valij=double(valij);
    bagstemp=[];
    nbi=0;
    for u=1:length(indi)
        if valij(u)>0 %must-link
            for j=1:nbLabels
                if labels_bag(indi(u),j)==1 || labels_bag(indj(u),j)==1 %the other one should be very negative
                    nbi=nbi+1;
                    bagstemp(nbi).indexes=[indi(u),indj(u)];
                    bagstemp(nbi).labels=[j,j];
                    bagstemp(nbi).coeffs=[1,-1].*abs(valij(u));
                    bagstemp(nbi).y_bag=0;
%                     bagstemp(nbi).loss_string='exp_sensitive';
                    bagstemp(nbi).is_symmetric=1;
                    bagstemp(nbi).offset=offset_W;
                end
            end

        else %must-not-link
            %TODO:add sum h(-(x1+x2))
            tempi=labels_bag(indi(u),:)==1;
            tempj=labels_bag(indj(u),:)==1;
            ni=sum(tempi>0);
            nj=sum(tempj>0);
            nij_min=min(ni,nj);
            nij_max=max(ni,nj);
            %TODO: handle a vs abc
            if 1&& (ni==2 && nj==2 && isequal(tempi,tempj))
                indtemp=find(tempi);
                nbi=nbi+1;
                bagstemp(nbi).indexes=[indi(u),indj(u)];
                bagstemp(nbi).labels=[indtemp(1),indtemp(2)];
                bagstemp(nbi).coeffs=[1,-1].*abs(valij(u));
                bagstemp(nbi).y_bag=0;
%                 bagstemp(nbi).loss_string='exp_sensitive';
                bagstemp(nbi).is_symmetric=1;
                bagstemp(nbi).offset=offset_W;%PARAM

                nbi=nbi+1;
                bagstemp(nbi).indexes=[indi(u),indj(u)];
                bagstemp(nbi).labels=[indtemp(2),indtemp(1)];
                bagstemp(nbi).coeffs=[1,-1].*abs(valij(u));
                bagstemp(nbi).y_bag=0;
%                 bagstemp(nbi).loss_string='exp_sensitive';
                bagstemp(nbi).is_symmetric=1;
                bagstemp(nbi).offset=offset_W;%PARAM

            end
            if 0
                for j=1:nbLabels
                    if tempi(j)==1 && tempj(j)==1 && (all(tempi<=tempj) || all(tempj<=tempi) ) && (nij_min==1 || nij_max<=2)
                        %TODO:truth table instead
                        nbi=nbi+1;
                        bagstemp(nbi).indexes=[indi(u),indj(u)];
                        bagstemp(nbi).labels=[j,j];
                        bagstemp(nbi).coeffs=[1,1].*abs(valij(u));
                        bagstemp(nbi).y_bag=0;
%                         bagstemp(nbi).loss_string='exp_sensitive';
                        bagstemp(nbi).is_symmetric=1;
                        bagstemp(nbi).offset=offset_W;


                    end
                end
            end
        end
    end
    if ~isempty(bagstemp)
        bags=[bags;bagstemp(:)];
    end
end

for i=1:length(bags)
    bags(i).weight=1;
end


function bags=compute_bag_balances(labels_bag,loss_string);
[n,nLabels]=size(labels_bag);
temp=sum(labels_bag==1,1);
ind=find(temp);
temp=tril(ones(length(ind)));
temp=temp-diag(diag(temp));
[indi,indj]=find(temp);
indi=ind(indi);
indj=ind(indj);

if isempty(indi)
    bags=[];
    return;
end

for u=1:length(indi)
    bags(u,1)=compute_bag_balance(labels_bag,indi(u),indj(u),loss_string);
end


function bag=compute_bag_balance(labels_bag,i,j,loss_string);
indexes1=find(labels_bag(:,i)==1)';
indexes2=find(labels_bag(:,j)==1)';
temp1=ones(size(indexes1));
temp2=ones(size(indexes2));
bag.indexes=[indexes1,indexes2];
bag.labels=[i*temp1,j*temp2];
% bag.coeffs=[temp1/length(indexes1),-temp2/length(indexes2)];

n1=length(indexes1);
n2=length(indexes2);
n12=max(n1,n2);
n12=sqrt(n12);
bag.coeffs=n12*[temp1/n1,-temp2/n2];
bag.y_bag=0;
% bag.loss_string=loss_string;
% bag.loss_string='exp_sensitive';
bag.is_symmetric=1;
bag.offset=0;%PARAM

function labels_bag=compute_negative_bags(labels_bag,is_sparse_bags);
labels_bag=full(labels_bag);
[n,k]=size(labels_bag);
labels_bag=double(labels_bag>0);
if ~is_sparse_bags
    labels_bag(labels_bag==0)=-1;
    return;
end

C=labels_bag'*labels_bag;
knn=1;
C=C^knn;

labels_bag2=labels_bag*C;
labels_bag(labels_bag2 & ~labels_bag)=-1;

