function [fun,res]=compute_svm_classifier_liblinear(x,labels,C,options0);
%{
% Timothee Cour, 30-Sep-2010 01:54:13 -- DO NOT DISTRIBUTE

TODO:
support DAG (multiclass)
support X=X' directly in cpp? ; at least do transpose before sparse?
support no sparse
support non-double (and sparse/not sparse)

compilation:
compile_mex_liblinear
test: 
test_svmlin
%}

options.is_bias=1;
options.is_nd=1;% is x: nxd
options.margin=[];
options.weight_example=[]; % if not empty, replaces C

if nargin>=4
    options=getOptions(options,options0);
end

margin=double(options.margin);
weight_example=double(options.weight_example);
labels=labels(:);
[labels_unique,ignore,labels]=unique(labels);
labels=compute_y(labels);

if options.is_nd
    x=x';
end
if ~(issparse(x)&&isa(x,'double'))
    x=double(x);
    x=sparse(x);
end
[d,n]=size(x);
assert(numel(labels)==n);
if ~isempty(margin)
    assert(numel(margin)==n);
end
if ~isempty(weight_example)
    assert(numel(weight_example)==n);
    weight_example=weight_example*C;
    C=1;% resetting to 1
end

if options.is_bias
    str_bias='-B 1 ';
else
    str_bias='-B -1 ';
end

% result=compute_result_cross_validation(labels,x,weight_example,margin);
0;

%'-s 3 -c ' for hinge?
string=[str_bias,'-s 2 -c ',num2str(C)];%default
% string=[str_bias,'-s 0 -c ',num2str(C)];
% string=[str_bias,'-s 1 -c ',num2str(C)];%can be much slower sometimes
% string=[str_bias,'-s 2 -e 0.001 -c ',num2str(C)]; 
%setting e to smaller doesn't seem useful

% tic;
res=train(labels, x, weight_example, margin,string, 'col');
% toc;


% res = train(labels2, x,string, 'row');
%last dim is bias
assert(~isempty(res));

% net = train(dagsvm, tutor, x, y, C, kernel);

%TODO:adapt to multiscale
%TODO:voir why coeff_mult needed
if labels(1)==1; 
    coeff_mult=1;
else
    coeff_mult=-1;
end

if options.is_bias
    res.bias = coeff_mult*res.w(end);
    res.w = coeff_mult*vec(res.w(1:end-1));
else
    res.bias = 0;
    res.w = coeff_mult*vec(res.w);
end
fun=@(x)(compute_labels(x,res,labels_unique));

function result=compute_result_cross_validation(labels,x,weight_example,margin);
%{
TODO:
integrate more
support margin,weight_example
%}
weight_example=[];
margin=[];

% str_bias='-B -1 ';
str_bias='-B 1 ';
Cs=logspace2(1e-2,1e8,6);
% Cs=1e1;
for i=1:length(Cs)
    t=clock;
    C=Cs(i);
    string=[str_bias,'-s 2 -v 5 -c ',num2str(C)];
    accuracy=train(labels,x,weight_example,margin,string,'col');
    results(i).C=C;
    results(i).accuracy=accuracy;
    results(i).time=etime(clock,t);
    results(i)
end
result.results=results;
[ignore,ind]=max([results.accuracy]);
result.C=results(ind).C;
result.accuracy=results(ind).accuracy;
result.Cs=Cs;
result.ind=ind;


function [labels,scores]=compute_labels(x,res,labels_unique);
scores=x*res.w+res.bias;
scores=double(scores);
% scores=x'*res.w+res.bias;

% x_sparse=sparse(x);
% x_sparse=double(x_sparse);
% string=['-b 0'];
% string=['-b 1'];
% [predicted_label, accuracy, decision_values/prob_estimates] = predict(testing_label_vector, x, res,string,'col');
% [n,d]=size(x);
% temp=zeros(n,1);

% [ignore1,ignore,labels0] = predict(temp,x_sparse,res,string,'row');


% scores=x*res.w+res.bias;
% labels0=sign(scores);
labels=zeros(length(scores),1);
temp=scores>0;

labels(temp)=labels_unique(2);
labels(~temp)=labels_unique(1);

% [ignore,labels]=max(scores0,[],2);
% labels=labels_unique(labels);

function y=compute_y(labels);
% y=2*labels2mask(labels(:))-1;
y=2*(labels==2)-1;
y=double(y);
