/*
// Timothee Cour, 30-Sep-2010 01:54:13 -- DO NOT DISTRIBUTE

 * #include "mex_assert.cpp"
 * CAUTION: make sure this is used instead of <assert.h>, which can crash matlab:
 * Assertion failed: (0), function deserialize, file ...cpp, line 161.
Abort trap
 *
 * so make sure this <assert.h> is not redefining assert behavior
 */


#pragma once
//#include "Stack_trace_bak1.cpp"
//#include "Stack_trace_bak2.cpp"
#include "Stack_trace.cpp"

#ifndef __PRETTY_FUNCTION__
#define __PRETTY_FUNCTION__ "??"
#endif


//void disp(string s1,string s2);
void disp2(string s1,string s2);
void CRASH(){
    mexPrintf("CRASH called\n");
////    break "include/mex_util.cpp":87
////     break "~/programs/graphcut/include/mex_util.cpp":87
    double*a=NULL;
    a[0]=0;
}

//TODO:
// void compute_error_string(string condition,string line,string file,string &s){
//     s="MATLAB:error" + "!! Assert '%s' failed on line %d in file '%s'\n", #isOK, __LINE__, __FILE__) )
//     s="In "+"<a href=""matlab: opentoline(''"+file+"''",',num2str(stack(i).line),');">',stack(i).name,' at ',num2str(stack(i).line),'</a>']);    
// }



//MACROS
#define printLine mexPrintf("line %d in file '%s'\n", __LINE__, __FILE__)
#define printError mexErrMsgIdAndTxt("MATLAB:error","line %d in file '%s'\n", __LINE__, __FILE__)

#define MEX_ERROR(s,line,func,file)(void)mexErrMsgIdAndTxt("MATLAB:error","!! Assert '%s' failed on line %d, function %s, file '%s'\n", s, line,func,file)
#ifndef ASSERT_CRASHES
#define MEX_ERROR2(s,line,func,file) MEX_ERROR(s,line,func,file)
#else
#define MEX_ERROR2(s,line,func,file) ( (void)CRASH() )
#endif

void assert0_aux(const char*isOk,int line, const char*func,const char*file){
    stack_trace::print_stack_trace();
    MEX_ERROR2(isOk, line,func,file);
}

// #define assert_bak1( isOK ) \
// {if(!(isOK)) {stack_trace::print_stack_trace();MEX_ERROR2(#isOK, __LINE__,__PRETTY_FUNCTION__,__FILE__);};}

#define assert( isOK ) \
	( (isOK) ? \
	(void)0 : \
	(void)assert0_aux(#isOK,__LINE__,__PRETTY_FUNCTION__, __FILE__) )
	

# define assert2( isOK , msg)\
if(!(isOK)) {disp2(msg,#msg);stack_trace::print_stack_trace();MEX_ERROR2(#isOK, __LINE__,__PRETTY_FUNCTION__,__FILE__);}

# define check_bounds(i,n) \
if(i<0 || i>=n){stack_trace::print_stack_trace();mexErrMsgIdAndTxt("MATLAB:error","!! index out of bounds: 0<=%s<%s failed, with %s=%d, %s=%d on line %d, function %s, file %s\n", #i,#n,#i,i,#n,n, __LINE__,__PRETTY_FUNCTION__,__FILE__);}

#ifndef NDEBUG
# define ASSERT( isOK ) assert(isOK)
#else
# define ASSERT( isOK ) do {} while( false )
#endif


//mexErrMsgIdAndTxt("MATLAB:error","!! error\n");