function [errorCode,message]=mex_aux(filename,path,varargin);
% in case there is an #include file.cpp, put shared in the search
% path relative to location of mex file
% Timothee Cour, 30-Sep-2010 01:54:13 -- DO NOT DISTRIBUTE



%if doesnt find certain functions, make sure includeDir is correct

if exist('definePaths','file')==2
    isInclude=1;
    includeDir=getPaths('includeDir');
else
    isInclude=0;
    includeDir=pwd;
end

if nargout == 0
    isVerbose = 1;
else
    isVerbose = 0;
end

% % verbose:
% [errorCode,message]=mex_silent(isVerbose,'-v',['-I',includeDir],filename);%to display warnings
% disp(message);
% return;

k=0;

k=k+1;args{k}=isVerbose;
k=k+1;args{k}=filename;

if ~any(strcmp(varargin,'-g'))
    k=k+1;args{k}='-O';%-O2 not valid option
end

args=[args,varargin];
k=k+length(varargin);
% if ~isempty(option2)
%     k=k+1;args{k}=option2;
% end
if isInclude
    k=k+1;args{k}=['-I',includeDir];
end
% if ~isempty(option)
%     k=k+1;args{k}=option;
% end
if ispc %BUG otherwise?
    k=k+1;args{k}='-argcheck';
end


% is_no_mwSize=verLessThan2('7.3');%TODO: use feature inside .cpp (cf email)
% % is_no_mwSize=verLessThan2('7.5');
% if is_no_mwSize
%     k=k+1;args{k}='-DIS_NO_MWSIZE';
% end

if 1%TODO:voir
    k=k+1;args{k}='-largeArrayDims';
end

if 1%TODO:voir use lapack + blas
    k=k+1;args{k}='-lmwlapack';
    k=k+1;args{k}='-lmwblas';
end
if ~ismac && isunix
    k=k+1;args{k}='-ldl';
end

ind=find(strcmp(args,'-exe'));
is_exe=0;
if ~isempty(ind)
    is_exe=1;
    args(ind)=[];
    k=k-1;
end

if ismac && ~is_exe
    %% prevents crashing matlab when some symbols are not def'd; overrides option -undefined suppress
    if verLessThan('matlab', '7.9')
        k=k+1;args{k}='LDFLAGS=-bundle -Wl,-flat_namespace -undefined error -Wl,-exported_symbols_list,$MATLAB/extern/lib/maci/mexFunction.map';
    else
        k=k+1;args{k}='LDFLAGS=-bundle -Wl,-flat_namespace -undefined error -arch x86_64 -Wl,-exported_symbols_list,$MATLAB/extern/lib/maci64/mexFunction.map';
    end
end

% [matlabroot,'/bin/gccopts.sh']
%  -f /Users/timothee/research/programs/graphcut/compilation/gccopts_test.sh;

if is_exe
    %         k=k+1;args{k}='LDFLAGS=-bundle -Wl,-flat_namespace -undefined error -Wl';
    %         k=k+1;args{k}='LDFLAGS=-flat_namespace -undefined suppress';
    k=k+1;args{k}=['-DISMATEXE'];
    k=k+1;args{k}=['-f'];
    %         k=k+1;args{k}=[pwd,'/matopts_option.sh'];
    k=k+1;args{k}=[matlabroot,'/bin/matopts.sh'];
end

%% to export for matlab <7.1, use those 2 lines
% if ispc
%     k=k+1;args{k}=['-output'];
%     k=k+1;args{k}=changeExt(filename,'.dll');
% end

% weird: seems to be needed to avoid linking errors
% disp(args);
% if ~(ispc || ismac)
% %     drawnow();
%     disp(args);
% end



try
    oldDir = pwd;
    cd(path);
    [errorCode,message]=mex_silent(args{:});
    cd(oldDir);
catch
    cd(oldDir);
    %     rethrow(lasterr);
    error(lasterr); %TODO:voir
end


%{
if error cannot find anything, like:
Error using mex2
mex_sequence_alignment.cpp:16:24: error: mex_util.cpp: No such file or directory

then check paths.includeDir
it should contain mex_util.cpp
do getPaths to reset at current correct dir
%}
0;
%{
if isempty(option) && isempty(option2)
    [errorCode,message]=mex_silent(isVerbose,'-O',['-I',includeDir],filename);
elseif ~isempty(option) && isempty(option2)
    [errorCode,message]=mex_silent(isVerbose,'-O',['-I',includeDir],filename,option);
elseif isempty(option) && ~isempty(option2)
    [errorCode,message]=mex_silent(isVerbose,'-O',option2,['-I',includeDir],filename);
elseif ~isempty(option) && ~isempty(option2)
    [errorCode,message]=mex_silent(isVerbose,'-O',option2,['-I',includeDir],filename,option);
end
%}

% mex('-O',filename);
% mex(filename);


% if isempty(option) && isempty(option2)
%     mex('-O',['-I',includeDir],filename);
% elseif ~isempty(option) && isempty(option2)
%     mex('-O',['-I',includeDir],filename,option);
% elseif isempty(option) && ~isempty(option2)
%     mex('-O',option2,['-I',includeDir],filename);
% elseif ~isempty(option) && ~isempty(option2)
%     mex('-O',option2,['-I',includeDir],filename,option);
% end
