/*
// Timothee Cour, 30-Sep-2010 01:54:13 -- DO NOT DISTRIBUTE

[indi,indj,valij,margin,y,weights]=mex_bag_funs('bags_2_x',bags,F,nbLabels);
F:dxn
 *TODO:make faster by directly returning sparse matrix; make sure bags(i).labels is sorted ; returns indj indi order
*/

#undef NDEBUG
#include <math.h>
#include <mex.h>
#include "Matrix.cpp"
#include "MatrixOp.cpp"


class Bag{
    public:
        vector<int> indexes_example; //indexes of example
        vector<double> coeffs; //coeffs of example
        vector<int> labels; //labels of example
        double weight;
//         int fun_type; //type of loss function
//         const char*loss_string;
        int y_bag;
        bool is_symmetric;
        double offset;
        void deserialize(const mxArray*A,int i){
            Matrix<int>::readmxArray(getFieldByName(A,i,"indexes"),indexes_example,-1);
            Matrix<double>::readmxArray(getFieldByName(A,i,"coeffs"),coeffs);
            Matrix<int>::readmxArray(getFieldByName(A,i,"labels"),labels,-1);
            Matrix<double>::readmxArray(getFieldByName(A,i,"offset"),offset);
//             int fun_type=mxGetScalar(getFieldByName(A,i,"fun_type"));
//             loss_string=mxArrayToString(getFieldByName(A,i,"loss_string"));
            is_symmetric=(bool)(mxGetScalar(getFieldByName(A,i,"is_symmetric")));
//             if(strcmp(loss_string,"exp_sensitive")==0)
//                 is_symmetric=true;
//             else
//                 is_symmetric=false;
            Matrix<int>::readmxArray(getFieldByName(A,i,"y_bag"),y_bag);
            Matrix<double>::readmxArray(getFieldByName(A,i,"weight"),weight);
        }
        static int compute_bag_size(const mxArray*A,int i,bool&is_symmetric){
            int nb=mxGetNumberOfElements(getFieldByName(A,i,"indexes"));
            is_symmetric=(bool)(mxGetScalar(getFieldByName(A,i,"is_symmetric")));
//             const char*str=mxArrayToString(getFieldByName(A,i,"loss_string"));
//             is_symmetric=strcmp(str,"exp_sensitive")==0;
            if(is_symmetric)
                nb*=2;//caution
            return nb;
        }
        static void compute_bags_size_sum(const mxArray*A,int &nb,int &nt){
            int n=mxGetNumberOfElements(A);
            nt=0;
            nb=0;
            for(int i=0;i<n;i++){
                bool is_symmetric;
                nt+=compute_bag_size(A,i,is_symmetric);
                if(is_symmetric)
                    nb+=2;
                else
                    nb++;
            }
        }
        static void deserialize(const mxArray*A,vector<Bag>&bags){
            int n=mxGetNumberOfElements(A);
            bags.resize(n);
            for(int i=0;i<n;i++){
                bags[i].deserialize(A,i);
            }
        }
};

class Class_bags_2_x{
public:
    vector<int>indi,indj;
    vector<double>valij;
    int n,d,L;
    double*F;
    const mxArray *mx_bags;
    int nb;    
    vector<double>margin;
    vector<double>weights;
    vector<int>y;
    
    bool is_bias;
    
    void mexGate(int nargout, mxArray *out[], int nargin, const mxArray *in[]){
        getSizes(in[2],d, n);
        F=Matrix<double>::getData(in[2]);
        L=(int)mxGetScalar(in[3]);
        mx_bags=in[1];
        nb=mxGetNumberOfElements(mx_bags);
        is_bias=(bool)mxGetScalar(in[4]);
        initialize();
        bags_2_x();
        
        out[0]=Matrix<int>::tomxArray(indi,mxDOUBLE_CLASS,1);
        out[1]=Matrix<int>::tomxArray(indj,mxDOUBLE_CLASS,1);
        out[2]=Matrix<double>::tomxArray(valij);
        out[3]=Matrix<double>::tomxArray(margin);
        out[4]=Matrix<int>::tomxArray(y,mxDOUBLE_CLASS);
        out[5]=Matrix<double>::tomxArray(weights,mxDOUBLE_CLASS);
    }
    void initialize(){
    }
    void bags_2_x(){
        int nt,nb2;
        Bag::compute_bags_size_sum(mx_bags,nb2,nt);
        int nz;
        if(is_bias)
            nz=d*nt+nb2;
        else
            nz=d*nt;
        
        indi.resize(nz);
        indj.resize(nz);
        valij.resize(nz);
        
        Bag bag;
        int i_total=0;
        int ind=0;
        for(int b=0;b<nb;b++){
            bag.deserialize(mx_bags,b);
            bag_2_x(bag,ind,i_total);
        }
        assert(ind==nz);
    }
    void bag_2_x(Bag&bag,int&ind,int&i_total){
        int ind0=ind;
        double sum_coeffs=0;
        for(int u=0;u<bag.indexes_example.size();u++){
            int kl=bag.labels[u]*d;
            double*Fu=&F[bag.indexes_example[u]*d];
            double coeffu=bag.coeffs[u];
            sum_coeffs+=coeffu;
            for(int k=0;k<d;k++){
                indi[ind]=i_total;
                indj[ind]=k+kl;
                valij[ind]=Fu[k]*coeffu;
                ind++;
            }
        }
        if(is_bias){
            indi[ind]=i_total;
            indj[ind]=L*d;
            valij[ind]=sum_coeffs;
            ind++;
        }
        if(bag.is_symmetric){
            //exp_sensitive
            
            int ind1=ind;
            for(int u=ind0;u<ind1;u++){
                indi[ind]=indi[u]+1;
                indj[ind]=indj[u];
                valij[ind]=-valij[u];
                ind++;
            }
//             y.push_back(1);//TODO:voir; clean up with a duplicate bag instead
//             y.push_back(-1);
            y.push_back(0);//TODO:voir; clean up with a duplicate bag instead
            y.push_back(0);
            margin.push_back(1-bag.offset);
            margin.push_back(1-bag.offset);
            weights.push_back(bag.weight);
            weights.push_back(bag.weight);
            i_total+=2;
        }
        else{
            margin.push_back(1-bag.offset);
            y.push_back(bag.y_bag);
            weights.push_back(bag.weight);
            i_total++;
        }
    }
};

void mexFunction(int nargout, mxArray *out[], int nargin, const mxArray *in[]) {
    string s=mxArrayToString(in[0]);
    if(s=="bags_2_x"){
        Class_bags_2_x class1;
        class1.mexGate(nargout, out, nargin, in);
    }
    else
        assert(0);
}

