function result=minimize_bag_loss_LP(bags,F,nbLabels,options0);
%{
% Timothee Cour, 30-Sep-2010 01:54:13 -- DO NOT DISTRIBUTE

F:nxd
%}

options.is_bias=0;%global bias %default=0
options.is_bias_labels=0;%default=0(1 seems to be worse)
options.C=1e3;%PARAM
options.mode='SVM';%default
% options.mode='QP';
% options.mode='LP';

if nargin>=4
    options=getOptions(options,options0);
end

if options.is_bias_labels
    F(:,end+1)=1;%bias per class
end

if strcmp(options.mode,'QP')
    [x,margin,y]=compute_bags(bags,F,nbLabels,1,options.is_bias);
    problem=compute_QP(x,margin,options.C);
    result=compute_result(problem);
elseif strcmp(options.mode,'LP')
    [x,margin,y]=compute_bags(bags,F,nbLabels,1,options.is_bias);
    problem=compute_LP(x,margin,options.C);
    result=compute_result(problem);
elseif strcmp(options.mode,'SVM')
    [x,margin,y,weight_example]=compute_bags(bags,F,nbLabels,0,options.is_bias);
    weight_example=weight_example*options.C;
%     if isfield(options,weight_example)
%     if 1 %BOF...
%         weight_example=zeros(n,1);
%         temp=density(y0==1);
%         weight_example(y0==1)=1-temp;
%         weight_example(y0~=1)=temp;
%         weight_example=weight_example*C;
%     end
    
    result=compute_SVM(x,margin,options.C,y,weight_example);
    result.bias=repmat(result.bias,1,nbLabels);
else
    assert(0);
end

% w0=result.w;

[n,d]=size(F);

bias_shared=0;
if options.is_bias
    bias_shared=result.w(end);
    result.w=result.w(1:end-1);
end
result.w=reshape(result.w,d,nbLabels);
if options.is_bias_labels
    result.bias=result.w(d,:)+bias_shared;
    result.w=result.w(1:d-1,:);
else
    result.bias=bias_shared;
end

result.fun_scores=@compute_scores;
if 0
    display_loss(x,y,w0);
end
% score=compute_score(x,margin,result.w(:),C);
0;

function scores=compute_scores(F,result);
if isfield(result,'bias') && ~isempty(result.bias) && any(result.bias)
    scores=bsxfun(@plus,F*result.w,result.bias);
else
    scores=F*result.w;
end

function display_loss(x,y,w);
xw=x'*w;
% [energie,energie_w,energie_scores,energies]=compute_energie(xw,C,result.w,margin);
ind1=y==1;
ind2=y~=1;
[xw1,ind1b]=sort(xw(ind1));
[xw2,ind2b]=sort(xw(ind2));
plot([xw1;xw2]);
n=length(xw);
hold on
plot(zeros(n,1),'y');
hold off

%     scores=result.fun_scores(F,result);


function result=compute_result(problem);

% [r,res]             = mosekopt('symbcon');
% data.maxtime        = 100.0;
% data.symbcon        = res.symbcon;
% callback.iter       = @mosek_iter_callback;
% callback.iter       = 'myiter';
% callback.iterhandle = data;
% mosekopt('minimize',prob,[],callback);



if isempty(problem.H)
    [X,fval,exitflag,output,lambda]=linprog(problem.f,problem.A,problem.b,problem.Aeq,problem.beq,problem.lb,problem.ub,problem.x0);
else
    [X,fval,exitflag,output,lambda]=quadprog(problem.H,problem.f,problem.A,problem.b,problem.Aeq,problem.beq,problem.lb,problem.ub,problem.x0);
end
result.score=fval;
result.X=X;
result.w=problem.compute_w(X);
result.b=problem.compute_b(X);

% result.xw=problem.compute_xw(X);
% result.bxw=problem.compute_bxw(X);

0;

function [x,margin,y,weights]=compute_bags(bags,F,nbLabels,is_nd,is_bias);
[n,d]=size(F);
F=F';
F=double(F); %TODO:support
% assert(~isempty(bags));
[indi,indj,valij,margin,y,weights]=mex_bag_funs('bags_2_x',bags,F,nbLabels,is_bias);
ni=max(indi);
if isempty(ni)
    %HACK
    ni=1;
    indi=1;
    indj=1;
    valij=1;
    y=1;
    margin=[];
    weights=1;
    
%     ni=0;
end

if is_bias
    dW=d*nbLabels+1;
else
    dW=d*nbLabels;
end
if is_nd
    x=sparse(indi,indj,valij,ni,dW);
else
    x=sparse(indj,indi,valij,dW,ni);
end

function result=compute_SVM(x,margin,C,y0,weight_example);
[d,n]=size(x);
if nargin<5
    weight_example=[];
end

% ind=find(y==y(1)); %(should go with options.is_bias=0)
% ind=randperm2(n,round(n*0.5));
ind=1:2:n;
y=ones(n,1);
y(ind)=-1;
x(:,ind)=-x(:,ind);
options.is_bias=0;
options.is_nd=0;

options.margin=margin; %seems a bit better without special margin
options.weight_example=weight_example;
[fun,res]=compute_svm_classifier_liblinear(x,y,C,options);
result.w=res.w;
result.bias=res.bias;%TODO:voir

%{ 
%TODO
function result=compute_SVM_kernel(x,C,y);
[d,n]=size(x);
ind=find(y==-1); %(should go with options.is_bias=0)
x(:,ind)=-x(:,ind);
% options.is_bias=0;
[fun,res]=compute_svm_classifier_svmlin(x,y,C);
result.w=res.w;
result.bias=res.bias;%TODO:voir
%}

function problem=compute_LP(x,margin,C);
%{
min_{a,b,w} sum(a)+C*sum(b)
xw=x*w
a>=w
a>=-w
b>=0
b>=margin-xw

usually: margin=1

%%%%%%%%%%%
equiv form:
min_{w,xw,a,b,aw,awp,bxw} sum(a)+C*sum(b)

xw=x*w
aw=a-w
awp=a+w
% bxw=b+xw
bxw=b+xw-margin

b>=0
aw>=0
awp>=0
bxw>=0

%%%%%%%%%%%
equiv form:
min f'*X
st A*X=0
X>=Xmin

X=[w;xw;a;b;aw;awp;bxw];
Xmin=[-Inf*ones(d+n+d,1);zeros(n+d+d,1);margin];
f=[zeros(d+n,1);ones(d,1);C*ones(n,1);zeros(d+d+n,1)];

Id=speye(n);
In=speye(n);
Zd=sparse(n,n);
Zn=sparse(n,n);
A=   [x,-In,sparse(n,d+n+d+d+n)];
A=[A;Id,Zn,-Id,Zn,Id,Zd,Zn];
A=[A;-Id,Zn,-Id,Zn,Zd,Id,Zn];
A=[A;Zd,-In,Zd,-In,Zd,Zd,In];

xw-x*w
aw-a+w
awp-a-w
% bxw-b-xw
bxw-b-xw=-margin
%}


[n,d]=size(x);
dims=[d;n;d;n;d;d;n];
indexes=lengths2indexes(dims);

% Xmin=[-Inf*zeros(d+n+d,1);zeros(n+d+d,1);margin];
Xmin=[-Inf*ones(d+n+d,1);zeros(n+d+d,1);zeros(n,1)];
f=[zeros(d+n,1);ones(d,1);C*ones(n,1);zeros(d+d+n,1)];

Id=speye(d);
In=speye(n);
Zdn=sparse(d,n);
Zdd=sparse(d,d);
% Zn=sparse(n,n);
Znd=sparse(n,d);
A=   [x,-In,sparse(n,d+n+d+d+n)];
A=[A;Id,Zdn,-Id,Zdn,Id,Zdd,Zdn];
A=[A;-Id,Zdn,-Id,Zdn,Zdd,Id,Zdn];
A=[A;Znd,-In,Znd,-In,Znd,Znd,In];

problem.H=[];
problem.A=[];
problem.b=[];
problem.Aeq=A;
% problem.beq=zeros(size(A,1),1);
problem.beq=[zeros(n+d+d,1);-margin];
problem.f=f;
problem.lb=Xmin;
problem.ub=[];
problem.x0=[];

problem.compute_w=@(X)(X(indexes{1}));
problem.compute_a=@(X)(X(indexes{3}));
problem.compute_b=@(X)(X(indexes{4}));
problem.compute_xw=@(X)(X(indexes{2}));
problem.compute_bxw=@(X)(X(indexes{7}));

%% for debug

function [energie,energie_w,energie_scores,energies]=compute_energie(scores,C,w,margin);
w=w(:);
if isempty(margin)
    energies=max(1-scores,0).^2;
else
    energies=max(margin-scores,0).^2;
end

% score=C*sum(scores)+sum(abs(w));
energie_w=0.5*w'*w;
energie_scores=C*sum(energies);
energie=energie_scores+energie_w;


function problem=compute_QP(x,margin,C);
%{
TODO:when is_square_loss==1, remove useless constraint b>=0
%}
is_square_loss=1;
% is_square_loss=0;

%{
min_{b,w} w'*w + C*sum(b)
xw=x*w
b>=0
b>=margin-x*w

usually: margin=1

%%%%%%%%%%%
equiv form:
min f'*X + 0.5*X'*H*X
st A*X=0
X>=Xmin
%}

% X=[w;b];

[n,d]=size(x);
dims=[d;n;n];
indexes=lengths2indexes(dims);

% Xmin=[-Inf*ones(d,1);zeros(n,1)];
% Xmin=[];

if is_square_loss
    f=zeros(d+n,1);
    H=2*blkdiag(speye(d),C*speye(n));
else
    f=[zeros(d,1);C*ones(n,1)];
    H=2*blkdiag(speye(d),sparse(n,n));
end

In=speye(n);
% Znd=sparse(n,d);
% A=-[x,In];
% b=-margin;
A=-[x,In;sparse(n,d),speye(n)];
b=[-margin;zeros(n,1)];

problem.H=H;
problem.A=A;
problem.b=b;
problem.Aeq=[];
problem.beq=[];
problem.f=f;
problem.lb=[];
problem.ub=[];
problem.x0=[];

problem.compute_w=@(X)(X(indexes{1}));
problem.compute_b=@(X)(X(indexes{2}));

