function [F2,a,b]=normalizeFeatures(F);
%{
% Timothee Cour, 30-Sep-2010 01:54:13 -- DO NOT DISTRIBUTE

F2=bsxfun(@plus,bsxfun(@times,F,a'),b');
%}

% F:nIxnF;
% for each column:y=a*x+b = alpha*(x-beta)
[nI,nf]=size(F);

beta=sum(F,1)/nI;
F=bsxfun(@plus,F,-beta);
alpha=sqrt(sum(F.^2,1)/nI);
ind=find(alpha>0);
alpha(ind)=1./alpha(ind);
F2=bsxfun(@times,F,alpha);

b=-alpha(:).*beta(:);
a=alpha(:);

0;

%{
function [F2,a,b]=normalizeFeatures_bak1(F);
% F:nIxnF;
% for each column:y=a*x+b = alpha*(x-beta)
[nI,nf]=size(F);

F2=zeros(nI,nf);
alpha=zeros(nf,1);
beta=zeros(nf,1);
for i=1:nf
    temp=F(:,i);
    beta(i)=sum(temp)/nI;
    temp=temp-beta(i);
    alpha(i)=sqrt(sum(temp.^2)/nI);
    if alpha(i)>0
        alpha(i)=1/(alpha(i));
    end
    F2(:,i)=alpha(i)*temp;
end
b=-alpha.*beta;
a=alpha;
%}

%{
% F:nFxnI;
% for each row:y=a*x+b = alpha*(x-beta)
[nf,nI]=size(F);
beta=mean(F,2);
F2=F-repmat(beta,1,nI);

alpha=1./(std(F,1,2)+eps);
F2=F2.*repmat(alpha,1,nI);
b=-alpha.*beta;
a=alpha;
%}



