classdef pca_funs
% Timothee Cour, 30-Sep-2010 01:54:13 -- DO NOT DISTRIBUTE

    methods(Static)
        function scratch();
        end
        function test();
        end
        function [X,lambda]=kernel_pca(X,is_kernel,d);
        %X:d0xn
        X=single(X);
        if ~is_kernel
            X=X'*X;
        end
        n=size(X,2);
        X1=sum(X,1)/n;
        Xt1=sum(X,2)/n;
        x=sum(X1)/n;
        X=bsxfun(@plus,X,-X1);
        X=bsxfun(@plus,X,-Xt1);
        X=X+x;
        X=(X+X')/2;
        
        if nargin<3
            [X,lambda]=eig(X);
            lambda=diag(lambda);
            X=bsxfun(@times,sqrt(max(0,lambda)),X); %scale rows
            0;
        else
            X=double(X);
            options=pca_funs.compute_options(n,d);
            funs=eigs_funs;
            result=funs.eigs_compatible_with_eigs_optimized(X,[],d,options);
            
            X=result.X;
            lambda=result.lambda;
        end
        
        
        end
        
        
        function options=compute_options(n,nbEigenvectors);
        options.issym = 1;
        options.maxit = 100;
        options.maxit = 500;
        options.tol = 1e-3;% 1e-3; 1e-4; 1e-2
        
        options.v0 = ones(n,1);
        options.p = nbEigenvectors*2;
        
        if nbEigenvectors==1
            options.p = 3;
        end
        options.p = min(round(options.p),n);
        
        options.fastMode = 1;
        options.computeX = 1;
        options.warningConvergence = 1;
        options.sigma = 'LA';
        options.n = n;
        
        assert(nbEigenvectors<=options.p-1 && nbEigenvectors>0);
        end
        
        function B=compute_AT_A_block(A,nb_blocks);
        [m,n]=size(A);
        indexes=splitIndexes_equal(1:m,nb_blocks);
        B=0;
        for i=1:length(indexes)
            Ai=A(indexes{i},:);
            Ai=Ai'*Ai;
            B=B+Ai;
        end
        end
        
    end
end
